Filters
Vue Bootstrap 5 Filters plugin
Filters are the best way to select data that meets your requirements - they affect your search results by filtrating and sorting the dataset you pass to our component.
Note: Read the API tab to find all available options and advanced customization
Basic example - DOM Elements
Use the items prop to define a container with data to filter. This
is required for proper component initialization.
Add data-mdb-filter-property to every item you want to be filtrable. If you
want to handle your filters by inputs, make a container for them, and add
data-mdb-filter-property to it.
Note: You must have at least one filtrable element for a component to work properly.
<template>
<MDBFilter
items=".basic-example-item"
:filters="{ color: colorRadio, sale: saleRadio }"
>
<MDBRow class="justify-content-center">
<MDBCol md="6">
<span class="fa-lg">Filter: Color</span>
<MDBRadio
label="Black"
wrapperClass="mt-3"
name="colorRadio"
v-model="colorRadio"
value="black"
/>
<MDBRadio
label="Red"
name="colorRadio"
v-model="colorRadio"
value="red"
/>
<MDBRadio
label="Blue"
name="colorRadio"
v-model="colorRadio"
value="blue"
/>
<MDBRadio
label="Gray"
name="colorRadio"
v-model="colorRadio"
value="gray"
/>
</MDBCol>
<MDBCol md="6">
<span class="fa-lg mb-5">Filter: Sale</span>
<MDBRadio
label="Yes"
wrapperClass="mt-3"
name="saleRadio"
v-model="saleRadio"
value="yes"
/>
<MDBRadio
label="No"
name="saleRadio"
v-model="saleRadio"
value="no"
/>
<MDBBtn
color="primary"
class="mt-3"
id="reset-button"
@click="resetRadios"
>
Clear all filters
</MDBBtn >
</MDBCol>
</MDBRow>
<MDBRow class="text-center">
<MDBCol
md="4"
class="mt-3 basic-example-item"
data-mdb-filter-color="black"
data-mdb-filter-sale="no"
data-mdb-filter-price="100"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Black Jeans Jacket</MDBCardTitle>
<MDBCardText>100$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 basic-example-item"
data-mdb-filter-sale="yes"
data-mdb-filter-color="gray"
data-mdb-filter-price="80"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Gray Jumper</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">100$</span>
<span class="fw-bold fa-lg ps-1">80$</span></MDBCardText
>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 basic-example-item"
data-mdb-filter-color="blue"
data-mdb-filter-sale="no"
data-mdb-filter-price="90"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Blue Jeans Jacket</MDBCardTitle>
<MDBCardText>90$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 basic-example-item"
data-mdb-filter-color="red"
data-mdb-filter-sale="yes"
data-mdb-filter-price="120"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Red Hoodie</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">150$</span>
<span class="fw-bold fa-lg ps-1">120$</span></MDBCardText
>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 basic-example-item"
data-mdb-filter-color="black"
data-mdb-filter-sale="no"
data-mdb-filter-price="100"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Black Jeans Jacket</MDBCardTitle>
<MDBCardText>100$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 basic-example-item"
data-mdb-filter-color="gray"
data-mdb-filter-sale="yes"
data-mdb-filter-price="80"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Gray Jumper</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">100$</span>
<span class="fw-bold fa-lg ps-1">80$</span></MDBCardText
>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
</MDBRow>
</MDBFilter>
</template>
<script>
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBRadio,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
} from "mdb-vue-ui-kit";
export default {
name: "App",
components: {
MDBFilter,
MDBRow,
MDBCol,
MDBRadio,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
},
setup() {
const colorRadio = ref("");
const saleRadio = ref("");
const resetRadios = () => {
colorRadio.value = "";
saleRadio.value = "";
};
return {
colorRadio,
saleRadio,
resetRadios,
};
},
};
</script>
<script setup lang="ts">
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBRadio,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
} from "mdb-vue-ui-kit";
const colorRadio = ref("");
const saleRadio = ref("");
const resetRadios = () => {
colorRadio.value = "";
saleRadio.value = "";
}
</script>
Checkbox example
Note: If there is more than one option, the result of filtering will show items that match both of them.
<template>
<MDBFilter
items=".checkbox-example-item"
:filters="{ color: colorCheckboxes, sale: saleCheckboxes }"
>
<MDBRow class="justify-content-center">
<MDBCol md="6">
<span class="fa-lg">Filter: Color</span>
<MDBCheckbox
label="Red"
v-model="colorCheckboxes.red"
wrapperClass="mt-3"
/>
<MDBCheckbox label="Blue" v-model="colorCheckboxes.blue" />
<MDBCheckbox label="Black" v-model="colorCheckboxes.black" />
<MDBCheckbox label="Gray" v-model="colorCheckboxes.gray" />
</MDBCol>
<MDBCol md="6">
<span class="fa-lg mb-5">Filter: Sale</span>
<MDBCheckbox
label="Yes"
wrapperClass="mt-3"
v-model="saleCheckboxes.yes"
/>
<MDBCheckbox label="No" v-model="saleCheckboxes.no" />
<MDBBtn
color="primary"
class="mt-3"
id="reset-button"
@click="resetCheckboxes"
>
Clear all filters
</MDBBtn >
</MDBCol>
</MDBRow>
<MDBRow class="text-center">
<MDBCol
md="4"
class="mt-3 checkbox-example-item"
data-mdb-filter-color="black"
data-mdb-filter-sale="no"
data-mdb-filter-price="100"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Black Jeans Jacket</MDBCardTitle>
<MDBCardText>100$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 checkbox-example-item"
data-mdb-filter-sale="yes"
data-mdb-filter-color="gray"
data-mdb-filter-price="80"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Gray Jumper</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">100$</span>
<span class="fw-bold fa-lg ps-1">80$</span></MDBCardText
>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 checkbox-example-item"
data-mdb-filter-color="blue"
data-mdb-filter-sale="no"
data-mdb-filter-price="90"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Blue Jeans Jacket</MDBCardTitle>
<MDBCardText>90$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 checkbox-example-item"
data-mdb-filter-color="red"
data-mdb-filter-sale="yes"
data-mdb-filter-price="120"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Red Hoodie</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">150$</span>
<span class="fw-bold fa-lg ps-1">120$</span></MDBCardText
>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 checkbox-example-item"
data-mdb-filter-color="black"
data-mdb-filter-sale="no"
data-mdb-filter-price="100"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Black Jeans Jacket</MDBCardTitle>
<MDBCardText>100$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 checkbox-example-item"
data-mdb-filter-color="gray"
data-mdb-filter-sale="yes"
data-mdb-filter-price="80"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Gray Jumper</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">100$</span>
<span class="fw-bold fa-lg ps-1">80$</span></MDBCardText
>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
</MDBRow>
</MDBFilter>
</template>
<script>
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBCheckbox,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
} from "mdb-vue-ui-kit";
export default {
name: "App",
components: {
MDBFilter,
MDBRow,
MDBCol,
MDBCheckbox,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
},
setup() {
const colorCheckboxes = ref({
red: false,
blue: false,
black: false,
gray: false,
});
const saleCheckboxes = ref({
yes: false,
no: false,
});
const resetCheckboxes = () => {
Object.keys(colorCheckboxes.value).forEach((key) => {
colorCheckboxes.value[key] = false;
});
Object.keys(saleCheckboxes.value).forEach((key) => {
saleCheckboxes.value[key] = false;
});
};
return {
colorCheckboxes,
saleCheckboxes,
resetCheckboxes,
};
},
};
</script>
<script setup lang="ts">
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBCheckbox,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
} from "mdb-vue-ui-kit";
const colorCheckboxes = ref({
red: false,
blue: false,
black: false,
gray: false,
});
const saleCheckboxes = ref({
yes: false,
no: false,
});
const resetCheckboxes = () => {
Object.keys(colorCheckboxes.value).forEach((key) => {
colorCheckboxes.value[key as keyof typeof colorCheckboxes.value] = false;
});
Object.keys(saleCheckboxes.value).forEach((key) => {
saleCheckboxes.value[key as keyof typeof saleCheckboxes.value] = false;
});
};
</script>
Color example
<template>
<MDBFilter
items=".color-example-item"
:filters="{ color: colorButtonsRadio }"
>
<MDBRow class="justify-content-center">
<MDBCol md="12" class="text-center mb-3">
<p class="fa-lg mt-2 mb-4">Filter: Color</p>
<MDBRadio
inline
label=" "
labelClass="btn bg-danger btn-rounded p-4"
name="colorButtonsRadio"
v-model="colorButtonsRadio"
value="red"
hidden
/>
<MDBRadio
inline
label=" "
labelClass="btn bg-primary btn-rounded p-4"
name="colorButtonsRadio"
v-model="colorButtonsRadio"
value="blue"
hidden
/>
<MDBRadio
inline
label=" "
labelClass="btn bg-dark btn-rounded p-4"
name="colorButtonsRadio"
v-model="colorButtonsRadio"
value="black"
hidden
/>
<MDBRadio
inline
label=" "
labelClass="btn bg-dark opacity-50 btn-rounded p-4"
name="colorButtonsRadio"
v-model="colorButtonsRadio"
value="gray"
hidden
/>
</MDBCol>
<MDBCol md="12" class="my-3 text-center">
<MDBBtn
color="primary"
class="mt-3"
id="reset-button"
@click="resetButtonsRadio"
>
Clear all filters
</MDBBtn>
</MDBCol>
</MDBRow>
<MDBRow class="text-center">
<MDBCol
md="4"
class="mt-3 color-example-item"
data-mdb-filter-color="black"
data-mdb-filter-sale="no"
data-mdb-filter-price="100"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Black Jeans Jacket</MDBCardTitle>
<MDBCardText>100$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 color-example-item"
data-mdb-filter-sale="yes"
data-mdb-filter-color="gray"
data-mdb-filter-price="80"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Gray Jumper</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">100$</span>
<span class="fw-bold fa-lg ps-1">80$</span></MDBCardText
>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 color-example-item"
data-mdb-filter-color="blue"
data-mdb-filter-sale="no"
data-mdb-filter-price="90"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Blue Jeans Jacket</MDBCardTitle>
<MDBCardText>90$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 color-example-item"
data-mdb-filter-color="red"
data-mdb-filter-sale="yes"
data-mdb-filter-price="120"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Red Hoodie</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">150$</span>
<span class="fw-bold fa-lg ps-1">120$</span></MDBCardText
>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 color-example-item"
data-mdb-filter-color="black"
data-mdb-filter-sale="no"
data-mdb-filter-price="100"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Black Jeans Jacket</MDBCardTitle>
<MDBCardText>100$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 color-example-item"
data-mdb-filter-color="gray"
data-mdb-filter-sale="yes"
data-mdb-filter-price="80"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Gray Jumper</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">100$</span>
<span class="fw-bold fa-lg ps-1">80$</span></MDBCardText
>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
</MDBRow>
</MDBFilter>
</template>
<script>
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBRadio,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
} from "mdb-vue-ui-kit";
export default {
name: "App",
components: {
MDBFilter,
MDBRow,
MDBCol,
MDBRadio,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
},
setup() {
const colorButtonsRadio = ref("");
const resetButtonsRadio = () => {
colorButtonsRadio.value = "";
};
return {
colorButtonsRadio,
resetButtonsRadio,
};
},
};
</script>
<script setup lang="ts">
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBRadio,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
} from "mdb-vue-ui-kit";
const colorButtonsRadio = ref("");
const resetButtonsRadio = () => {
colorButtonsRadio.value = "";
};
</script>
Size example
<template>
<MDBFilter
items=".size-item"
:filters="{ size: sizeCheckboxes, sale: saleRadio2 }"
>
<MDBRow class="justify-content-center">
<MDBCol md="6" data-mdb-filter-filter="size">
<span class="fa-lg">Filter: Size</span>
<MDBCheckbox
label="36"
v-model="sizeCheckboxes['36']"
wrapperClass="mt-3"
/>
<MDBCheckbox label="38" v-model="sizeCheckboxes['38']" />
<MDBCheckbox label="40" v-model="sizeCheckboxes['40']" />
<MDBCheckbox label="42" v-model="sizeCheckboxes['42']" />
</MDBCol>
<MDBCol md="6">
<span class="fa-lg mb-5">Filter: Sale</span>
<MDBRadio
label="Yes"
wrapperClass="mt-3"
name="saleRadio2"
v-model="saleRadio2"
value="yes"
/>
<MDBRadio
label="No"
name="saleRadio2"
v-model="saleRadio2"
value="no"
/>
<MDBBtn
color="primary"
class="mt-3"
id="reset-button"
@click="resetFilters"
>
Clear all filters
</MDBBtn >
</MDBCol>
</MDBRow>
<MDBRow class="text-center">
<MDBCol
md="4"
class="mt-3 size-item"
data-mdb-filter-size="[36,38,40,42]"
data-mdb-filter-sale="no"
data-mdb-filter-price="100"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Black Jeans Jacket</MDBCardTitle>
<MDBCardText>100$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 size-item"
data-mdb-filter-sale="yes"
data-mdb-filter-size="[40,42]"
data-mdb-filter-price="80"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Gray Jumper</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">100$</span>
<span class="fw-bold fa-lg ps-1">80$</span></MDBCardText
>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 size-item"
data-mdb-filter-size="[38]"
data-mdb-filter-sale="no"
data-mdb-filter-price="90"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Blue Jeans Jacket</MDBCardTitle>
<MDBCardText>90$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 size-item"
data-mdb-filter-size="[36]"
data-mdb-filter-sale="yes"
data-mdb-filter-price="120"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Red Hoodie</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">150$</span>
<span class="fw-bold fa-lg ps-1">120$</span></MDBCardText
>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 size-item"
data-mdb-filter-size="[36,40,42]"
data-mdb-filter-sale="no"
data-mdb-filter-price="100"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Black Jeans Jacket</MDBCardTitle>
<MDBCardText>100$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 size-item"
data-mdb-filter-size="[36,38,40]"
data-mdb-filter-sale="yes"
data-mdb-filter-price="80"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Gray Jumper</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">100$</span>
<span class="fw-bold fa-lg ps-1">80$</span></MDBCardText
>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
</MDBRow>
</MDBFilter>
</template>
<script>
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBCheckbox,
MDBRadio,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
} from "mdb-vue-ui-kit";
export default {
name: "App",
components: {
MDBFilter,
MDBRow,
MDBCol,
MDBCheckbox,
MDBRadio,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
},
setup() {
const sizeCheckboxes = ref({
36: false,
38: false,
40: false,
42: false,
});
const saleRadio2 = ref("");
const resetFilters = () => {
Object.keys(sizeCheckboxes.value).forEach((key) => {
sizeCheckboxes.value[key] = false;
});
saleRadio2.value = "";
};
return {
sizeCheckboxes,
saleRadio2,
resetFilters,
};
},
};
</script>
<script setup lang="ts">
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBCheckbox,
MDBRadio,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
} from "mdb-vue-ui-kit";
const sizeCheckboxes = ref({
36: false,
38: false,
40: false,
42: false,
});
const saleRadio2 = ref("");
const resetFilters = () => {
Object.keys(sizeCheckboxes.value).forEach((key) => {
sizeCheckboxes.value[key as keyof typeof sizeCheckboxes.value] = false;
});
saleRadio2.value = "";
};
</script>
Animations with DOM Elements
Add data-mdb-filter-animation attribute with animation type to filtrable elements to
animate them. The full list of available animations you can find
here.
<template>
<MDBFilter
items=".animation-dom-item"
data-mdb-filter-animation="fade-in"
:filters="{ color: colorRadio3, sale: saleRadio3 }"
>
<MDBRow class="justify-content-center">
<MDBCol md="6">
<span class="fa-lg">Filter: Color</span>
<MDBRadio
label="Black"
wrapperClass="mt-3"
name="colorRadio3"
v-model="colorRadio3"
value="black"
/>
<MDBRadio
label="Red"
name="colorRadio3"
v-model="colorRadio3"
value="red"
/>
<MDBRadio
label="Blue"
name="colorRadio3"
v-model="colorRadio3"
value="blue"
/>
<MDBRadio
label="Gray"
name="colorRadio3"
v-model="colorRadio3"
value="gray"
/>
</MDBCol>
<MDBCol md="6">
<span class="fa-lg mb-5">Filter: Sale</span>
<MDBRadio
label="Yes"
wrapperClass="mt-3"
name="saleRadio3"
v-model="saleRadio3"
value="yes"
/>
<MDBRadio
label="No"
name="saleRadio3"
v-model="saleRadio3"
value="no"
/>
<MDBBtn
color="primary"
class="mt-3"
id="reset-button"
@click="resetRadios3"
>
Clear all filters
</MDBBtn>
</MDBCol>
</MDBRow>
<MDBRow class="text-center">
<MDBCol
md="4"
class="mt-3 animation-dom-item"
data-mdb-filter-animation="fade-in"
data-mdb-filter-color="black"
data-mdb-filter-sale="no"
data-mdb-filter-price="100"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Black Jeans Jacket</MDBCardTitle>
<MDBCardText>100$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 animation-dom-item"
data-mdb-filter-animation="fade-in"
data-mdb-filter-sale="yes"
data-mdb-filter-color="gray"
data-mdb-filter-price="80"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Gray Jumper</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">100$</span>
<span class="fw-bold fa-lg ps-1">80$</span>
</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 animation-dom-item"
data-mdb-filter-animation="fade-in"
data-mdb-filter-color="blue"
data-mdb-filter-sale="no"
data-mdb-filter-price="90"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Blue Jeans Jacket</MDBCardTitle>
<MDBCardText>90$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 animation-dom-item"
data-mdb-filter-animation="fade-in"
data-mdb-filter-color="red"
data-mdb-filter-sale="yes"
data-mdb-filter-price="120"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Red Hoodie</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">150$</span>
<span class="fw-bold fa-lg ps-1">120$</span>
</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 animation-dom-item"
data-mdb-filter-animation="fade-in"
data-mdb-filter-color="black"
data-mdb-filter-sale="no"
data-mdb-filter-price="100"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Black Jeans Jacket</MDBCardTitle>
<MDBCardText>100$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 animation-dom-item"
data-mdb-filter-animation="fade-in"
data-mdb-filter-color="gray"
data-mdb-filter-sale="yes"
data-mdb-filter-price="80"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Gray Jumper</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">100$</span>
<span class="fw-bold fa-lg ps-1">80$</span>
</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
</MDBRow>
</MDBFilter>
</template>
<script>
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBRadio,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
} from "mdb-vue-ui-kit";
export default {
name: "App",
components: {
MDBFilter,
MDBRow,
MDBCol,
MDBRadio,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
},
setup() {
const colorRadio3 = ref("");
const saleRadio3 = ref("");
const resetRadios3 = () => {
colorRadio3.value = "";
saleRadio3.value = "";
};
return {
colorRadio3,
saleRadio3,
resetRadios3,
};
},
};
</script>
<script setup lang="ts">
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBRadio,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
} from "mdb-vue-ui-kit";
const colorRadio3 = ref("");
const saleRadio3 = ref("");
const resetRadios3 = () => {
colorRadio3.value = "";
saleRadio3.value = "";
};
</script>
Data structure - array
Note: Your items dataset can be an array of items. We made
this solution for backend needs.
<template>
<MDBRow class="justify-content-center">
<MDBCol md="6">
<span class="fa-lg">Filter: Color</span>
<MDBRadio
label="Black"
wrapperClass="mt-3"
name="colorRadio4"
v-model="colorRadio4"
value="black"
/>
<MDBRadio
label="Red"
name="colorRadio4"
v-model="colorRadio4"
value="red"
/>
<MDBRadio
label="Blue"
name="colorRadio4"
v-model="colorRadio4"
value="blue"
/>
<MDBRadio
label="Gray"
name="colorRadio4"
v-model="colorRadio4"
value="gray"
/>
</MDBCol>
<MDBCol md="6">
<span class="fa-lg mb-5">Filter: Sale</span>
<MDBRadio
label="Yes"
wrapperClass="mt-3"
name="saleRadio4"
v-model="saleRadio4"
value="yes"
/>
<MDBRadio
label="No"
name="saleRadio4"
v-model="saleRadio4"
value="no"
/>
<MDBBtn
color="primary"
class="mt-3"
id="reset-button"
@click="resetRadios4"
>
Clear all filters
</MDBBtn>
</MDBCol>
</MDBRow>
<MDBFilter
:dataset="filterDataset"
:template="filterTemplate"
:filters="{ color: colorRadio4, sale: saleRadio4 }"
items=".filter-item"
class="row text-center"
/>
</template>
<script>
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBRadio,
MDBBtn
} from "mdb-vue-ui-kit";
export default {
name: "App",
components: {
MDBFilter,
MDBRow,
MDBCol,
MDBRadio,
MDBBtn
},
setup() {
const colorRadio4 = ref("");
const saleRadio4 = ref("");
const resetRadios4 = () => {
colorRadio4.value = "";
saleRadio4.value = "";
};
const filterDataset = ref([
{
id: 1,
color: "black",
price: 100,
sale: "no",
product: "Black Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
},
{
id: 2,
color: "black",
price: 100,
sale: "no",
product: "Black Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
},
{
id: 3,
color: "gray",
price: 80,
sale: "yes",
product: "Gray Jumper",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
},
{
id: 4,
color: "gray",
price: 80,
sale: "yes",
product: "Gray Jumper",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
},
{
id: 5,
color: "red",
price: 120,
sale: "yes",
product: "Red Hoodie",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.jpg",
},
{
id: 6,
color: "blue",
price: 90,
sale: "no",
product: "Blue Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.jpg",
},
]);
const filterTemplate = (item) => `
<div class="col-md-4 mt-3 filter-item" data-mdb-filter-color="${item.color}" data-mdb-filter-sale="${item.sale}">
<div class="card shadow-2">
<img src="${item.img}" class="card-img-top" alt="..." />
<div class="card-body">
<h5 class="card-title">${item.product}</h5>
<p class="card-text">${item.price}$</p>
<a href="#" class="btn btn-primary ripple-surface">Buy now</a>
</div>
</div>
</div>
`;
return {
colorRadio4,
saleRadio4,
resetRadios4,
filterDataset,
filterTemplate,
};
},
};
</script>
<script setup lang="ts">
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBRadio,
MDBBtn
} from "mdb-vue-ui-kit";
interface FilterItem {
id: number;
color: string;
price: number;
sale: string;
product: string;
img?: string;
image?: string;
name: string;
}
const colorRadio4 = ref("");
const saleRadio4 = ref("");
const resetRadios4 = () => {
colorRadio4.value = "";
saleRadio4.value = "";
};
const filterDataset = ref([
{
id: 1,
color: "black",
price: 100,
sale: "no",
product: "Black Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
},
{
id: 2,
color: "black",
price: 100,
sale: "no",
product: "Black Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
},
{
id: 3,
color: "gray",
price: 80,
sale: "yes",
product: "Gray Jumper",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
},
{
id: 4,
color: "gray",
price: 80,
sale: "yes",
product: "Gray Jumper",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
},
{
id: 5,
color: "red",
price: 120,
sale: "yes",
product: "Red Hoodie",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.jpg",
},
{
id: 6,
color: "blue",
price: 90,
sale: "no",
product: "Blue Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.jpg",
},
]);
const filterTemplate = (item: FilterItem) => `
<div class="col-md-4 mt-3 filter-item" data-mdb-filter-color="${item.color}" data-mdb-filter-sale="${item.sale}">
<div class="card shadow-2">
<img src="${item.img}" class="card-img-top" alt="..." />
<div class="card-body">
<h5 class="card-title">${item.product}</h5>
<p class="card-text">${item.price}$</p>
<a href="#" class="btn btn-primary ripple-surface">Buy now</a>
</div>
</div>
</div>
`;
</script>
Spinner & Asynchronous Data example
Price:
<template>
<MDBRow class="justify-content-center mb-5">
<p class="text-center fa-lg fw-bold">Price:</p>
<MDBCol md="3" class="mt-3 text-center">
<MDBInput
type="number"
v-model="defaultMinPrice"
@change="handleMinPriceChange"
/>
</MDBCol>
<MDBCol md="3" class="mt-3 text-center">
<MDBInput
type="number"
v-model="defaultMaxPrice"
@change="handleMaxPriceChange"
/>
</MDBCol>
</MDBRow>
<MDBRow v-if="loading" class="text-center mb-5">
<MDBCol md="12">
<MDBSpinner grow color="primary" />
</MDBCol>
</MDBRow>
<MDBFilter
v-else
:dataset="filterDataset2"
:template="filterTemplate2"
:filters="{ price: { min: minPrice, max: maxPrice } }"
items=".filter-item"
class="row text-center mt-3"
style="max-height: 800px; overflow-y: scroll"
/>
</template>
<script>
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBInput,
MDBSpinner,
} from "mdb-vue-ui-kit";
export default {
name: "App",
components: {
MDBFilter,
MDBRow,
MDBCol,
MDBInput,
MDBSpinner,
},
setup() {
const defaultMinPrice = ref(0);
const defaultMaxPrice = ref(200);
const minPrice = ref(0);
const maxPrice = ref(200);
const loading = ref(true);
const filterDataset2 = ref([]);
const loadData = () => {
loading.value = true;
setTimeout(() => {
fetch("products.json")
.then((response) => response.json())
.then((data) => {
filterDataset2.value = data;
loading.value = false;
});
}, 1000);
};
const filterTemplate2 = (item) => `
<div class="col-md-4 mt-3 filter-item" data-mdb-filter-price="${item.price}">
<div class="card shadow-2">
<img src="${item.image}" class="card-img-top" alt="..." />
<div class="card-body">
<h5 class="card-title">${item.name}</h5>
<p class="card-text">${item.price}$</p>
<a href="#" class="btn btn-primary ripple-surface">Buy now</a>
</div>
</div>
</div>
`;
loadData();
const handleMinPriceChange = (event) => {
minPrice.value = event.target.value;
loadData();
};
const handleMaxPriceChange = (event) => {
maxPrice.value = event.target.value;
loadData();
};
return {
defaultMinPrice,
defaultMaxPrice,
minPrice,
maxPrice,
filterDataset2,
filterTemplate2,
loading,
handleMinPriceChange,
handleMaxPriceChange,
};
},
};
</script>
<script setup lang="ts">
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBInput,
MDBSpinner,
} from "mdb-vue-ui-kit";
interface FilterItem {
id: number;
color: string;
price: number;
sale: string;
product: string;
img?: string;
image?: string;
name: string;
}
const defaultMinPrice = ref(0);
const defaultMaxPrice = ref(200);
const minPrice = ref<string | number>(0);
const maxPrice = ref<string | number>(200);
const loading = ref(true);
const filterDataset2 = ref<FilterItem[]>([]);
const loadData = () => {
loading.value = true;
setTimeout(() => {
fetch("products.json")
.then((response) => response.json())
.then((data) => {
filterDataset2.value = data;
loading.value = false;
});
}, 1000);
};
const filterTemplate2 = (item: FilterItem) => `
<div class="col-md-4 mt-3 filter-item" data-mdb-filter-price="${item.price}">
<div class="card shadow-2">
<img src="${item.image}" class="card-img-top" alt="..." />
<div class="card-body">
<h5 class="card-title">${item.name}</h5>
<p class="card-text">${item.price}$</p>
<a href="#" class="btn btn-primary ripple-surface">Buy now</a>
</div>
</div>
</div>
`;
loadData();
const handleMinPriceChange = (event: Event) => {
minPrice.value = (event.target as HTMLInputElement).value;
loadData();
};
const handleMaxPriceChange = (event: Event) => {
maxPrice.value = (event.target as HTMLInputElement).value;
loadData();
};
</script>
[
{
"id": 1,
"category": "shirts",
"name": "Fantasy T-shirt",
"rating": 4,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["34", "36", "40"],
"condition": "new",
"color": "blue",
"price": 12.99,
"keywords": ["t-shirt", "sweatshitrt"],
"discount": 0,
"gender": "male"
},
{
"id": 2,
"category": "shirts",
"name": "Fantasy T-shirt",
"rating": 5,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["34", "36", "40", "44"],
"condition": "new",
"color": "red",
"price": 12.99,
"discount": 0,
"gender": "male"
},
{
"id": 3,
"category": "shirts",
"name": "Fantasy T-shirt",
"rating": 3,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["34", "36"],
"condition": "new",
"color": "grey",
"price": 40.99,
"discount": 10,
"gender": "male"
},
{
"id": 4,
"category": "jackets",
"name": "Denim Jacket",
"rating": 5,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"condition": "new",
"color": "grey",
"price": 40.99,
"discount": 0,
"gender": "unisex"
},
{
"id": 5,
"category": "jeans",
"name": "Ripped jeans",
"rating": 5,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/11.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["34", "36", "38", "40"],
"condition": "renewed",
"color": "blue",
"price": 20.99,
"discount": 5,
"gender": "female"
},
{
"id": 6,
"category": "jeans",
"name": "Boyfriend jeans",
"rating": 4,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/10.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": false,
"size": ["34", "36", "38", "40"],
"condition": "used",
"color": "blue",
"price": 20.99,
"discount": 5,
"gender": "female"
},
{
"id": 7,
"category": "shirts",
"name": "Ripped sweatshirt",
"rating": 4,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/7.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["34", "36", "38", "40"],
"condition": "collectible",
"color": "white",
"price": 29.99,
"discount": 5,
"gender": "female"
},
{
"id": 8,
"category": "shirts",
"name": "Longsleeve",
"rating": 4,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/8.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["40"],
"condition": "collectible",
"color": "black",
"price": 120.99,
"discount": 0,
"gender": "male"
},
{
"id": 8,
"category": "shirts",
"name": "Stripped sweatshirt",
"rating": 4,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/6.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["40", "38", "36"],
"condition": "new",
"color": "white",
"price": 32.99,
"discount": 10,
"gender": "female"
},
{
"id": 9,
"category": "trousers",
"name": "Red chinos",
"rating": 5,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/5.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["40", "38", "36"],
"condition": "new",
"color": "red",
"price": 62.99,
"discount": 10,
"gender": "female"
},
{
"id": 10,
"category": "coats",
"name": "Camel coat",
"rating": 5,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/4.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["40", "38", "36"],
"condition": "used",
"color": "brown",
"price": 62.99,
"discount": 10,
"gender": "female"
},
{
"id": 11,
"category": "jeans",
"name": "Blue jeans",
"rating": 5,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/3.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["40", "38", "36"],
"condition": "new",
"color": "blue",
"price": 42.99,
"discount": 0,
"gender": "female"
},
{
"id": 12,
"category": "shirts",
"name": "Orange T-shirt",
"rating": 3,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/3.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["40", "38", "36"],
"condition": "new",
"color": "orange",
"price": 12.99,
"discount": 0,
"gender": "female"
},
{
"id": 13,
"category": "skirts",
"name": "Ballerina skirt",
"rating": 4,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/2.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["38", "36"],
"condition": "collectible",
"color": "white",
"price": 12.99,
"discount": 0,
"gender": "female"
}
]
Animations - Array of Items
Add data-mdb-filter-animation attribute with animation type to filtrable elements to
animate them. The full list of available animations you can find
here.
<template>
<MDBRow class="justify-content-center">
<MDBCol md="6">
<span class="fa-lg">Filter: Color</span>
<MDBRadio
label="Black"
wrapperClass="mt-3"
name="colorRadio5"
v-model="colorRadio5"
value="black"
/>
<MDBRadio
label="Red"
name="colorRadio5"
v-model="colorRadio5"
value="red"
/>
<MDBRadio
label="Blue"
name="colorRadio5"
v-model="colorRadio5"
value="blue"
/>
<MDBRadio
label="Gray"
name="colorRadio5"
v-model="colorRadio5"
value="gray"
/>
</MDBCol>
<MDBCol md="6">
<span class="fa-lg mb-5">Filter: Sale</span>
<MDBRadio
label="Yes"
wrapperClass="mt-3"
name="saleRadio5"
v-model="saleRadio5"
value="yes"
/>
<MDBRadio
label="No"
name="saleRadio5"
v-model="saleRadio5"
value="no"
/>
<MDBBtn
color="primary"
class="mt-3"
id="reset-button"
@click="resetRadios5"
>
Clear all filters
</MDBBtn>
</MDBCol>
</MDBRow>
<MDBFilter
:dataset="filterDataset5"
:template="filterTemplate5"
:filters="{ color: colorRadio5, sale: saleRadio5 }"
items=".filter-item"
class="row text-center"
/>
</template>
<script>
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBRadio,
MDBBtn
} from "mdb-vue-ui-kit";
export default {
name: "App",
components: {
MDBFilter,
MDBRow,
MDBCol,
MDBRadio,
MDBBtn
},
setup() {
const colorRadio5 = ref("");
const saleRadio5 = ref("");
const resetRadios5 = () => {
colorRadio5.value = "";
saleRadio5.value = "";
};
const filterDataset5 = ref([
{
id: 1,
color: "black",
price: 100,
sale: "no",
product: "Black Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
},
{
id: 2,
color: "black",
price: 100,
sale: "no",
product: "Black Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
},
{
id: 3,
color: "gray",
price: 80,
sale: "yes",
product: "Gray Jumper",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
},
{
id: 4,
color: "gray",
price: 80,
sale: "yes",
product: "Gray Jumper",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
},
{
id: 5,
color: "red",
price: 120,
sale: "yes",
product: "Red Hoodie",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.jpg",
},
{
id: 6,
color: "blue",
price: 90,
sale: "no",
product: "Blue Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.jpg",
},
]);
const filterTemplate5 = (item) => `
<div
class="col-md-4 mt-3 filter-item"
data-mdb-filter-color="${item.color}"
data-mdb-filter-sale="${item.sale}"
data-mdb-filter-animation="fade-in"
>
<div class="card shadow-2">
<img src="${item.img}" class="card-img-top" alt="..." />
<div class="card-body">
<h5 class="card-title">${item.product}</h5>
<p class="card-text">${item.price}$</p>
<a href="#" class="btn btn-primary ripple-surface">Buy now</a>
</div>
</div>
</div>
`;
return {
colorRadio5,
saleRadio5,
resetRadios5,
filterDataset5,
filterTemplate5,
};
},
};
</script>
<script setup lang="ts">
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBRadio,
MDBBtn
} from "mdb-vue-ui-kit";
interface FilterItem {
id: number;
color: string;
price: number;
sale: string;
product: string;
img?: string;
image?: string;
name: string;
}
const colorRadio5 = ref("");
const saleRadio5 = ref("");
const resetRadios5 = () => {
colorRadio5.value = "";
saleRadio5.value = "";
};
const filterDataset5 = ref([
{
id: 1,
color: "black",
price: 100,
sale: "no",
product: "Black Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
},
{
id: 2,
color: "black",
price: 100,
sale: "no",
product: "Black Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
},
{
id: 3,
color: "gray",
price: 80,
sale: "yes",
product: "Gray Jumper",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
},
{
id: 4,
color: "gray",
price: 80,
sale: "yes",
product: "Gray Jumper",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
},
{
id: 5,
color: "red",
price: 120,
sale: "yes",
product: "Red Hoodie",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.jpg",
},
{
id: 6,
color: "blue",
price: 90,
sale: "no",
product: "Blue Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.jpg",
},
]);
const filterTemplate5 = (item: FilterItem) => `
<div
class="col-md-4 mt-3 filter-item"
data-mdb-filter-color="${item.color}"
data-mdb-filter-sale="${item.sale}"
data-mdb-filter-animation="fade-in"
>
<div class="card shadow-2">
<img src="${item.img}" class="card-img-top" alt="..." />
<div class="card-body">
<h5 class="card-title">${item.product}</h5>
<p class="card-text">${item.price}$</p>
<a href="#" class="btn btn-primary ripple-surface">Buy now</a>
</div>
</div>
</div>
`;
</script>
Filter and sort
<template>
<MDBRow>
<MDBCol md="6">
<span class="fa-lg">Filter: Color</span>
<MDBRadio label="Black" wrapperClass="mt-3" name="colorRadio6" v-model="colorRadio6" value="black" />
<MDBRadio label="Red" name="colorRadio6" v-model="colorRadio6" value="red" />
<MDBRadio label="Blue" name="colorRadio6" v-model="colorRadio6" value="blue" />
<MDBRadio label="Gray" name="colorRadio6" v-model="colorRadio6" value="gray" />
</MDBCol>
<MDBCol md="6">
<span class="fa-lg mb-5">Filter: Sale</span>
<MDBRadio label="Yes" wrapperClass="mt-3" name="saleRadio6" v-model="saleRadio6" value="yes" />
<MDBRadio label="No" name="saleRadio6" v-model="saleRadio6" value="no" />
<MDBBtn color="primary" class="mt-3" id="reset-button" @click="resetRadios6">
Clear all filters
</MDBBtn>
</MDBCol>
<MDBCol md="8" class="my-5">
<MDBSelect label="Sort" :preselect="false" placeholder="Choose category" v-model:options="sortingOptions6"
v-model:selected="sortingSelected6" />
</MDBCol>
</MDBRow>
<MDBFilter :dataset="filterDataset6" :template="filterTemplate6" :filters="{ color: colorRadio6, sale: saleRadio6 }"
:sort="sort6" items=".filter-item" class="row text-center" />
</template>
<script>
import { ref, watch } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBRadio,
MDBBtn,
MDBSelect
} from "mdb-vue-ui-kit";
export default {
name: "App",
components: {
MDBFilter,
MDBRow,
MDBCol,
MDBRadio,
MDBBtn,
MDBSelect
},
setup() {
const colorRadio6 = ref("");
const saleRadio6 = ref("");
const resetRadios6 = () => {
colorRadio6.value = "";
saleRadio6.value = "";
};
const filterDataset6 = ref([
{
id: 1,
color: "black",
price: 100,
sale: "no",
product: "Black Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
},
{
id: 2,
color: "black",
price: 100,
sale: "no",
product: "Black Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
},
{
id: 3,
color: "gray",
price: 80,
sale: "yes",
product: "Gray Jumper",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
},
{
id: 4,
color: "gray",
price: 80,
sale: "yes",
product: "Gray Jumper",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
},
{
id: 5,
color: "red",
price: 120,
sale: "yes",
product: "Red Hoodie",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.jpg",
},
{
id: 6,
color: "blue",
price: 90,
sale: "no",
product: "Blue Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.jpg",
},
]);
const filterTemplate6 = (item) => `
<div
class="col-md-4 mt-3 filter-item"
data-mdb-filter-color="${item.color}"
data-mdb-filter-sale="${item.sale}"
data-mdb-filter-animation="fade-in"
>
<div class="card shadow-2">
<img src="${item.img}" class="card-img-top" alt="..." />
<div class="card-body">
<h5 class="card-title">${item.product}</h5>
<p class="card-text">${item.price}$</p>
<a href="#" class="btn btn-primary ripple-surface">Buy now</a>
</div>
</div>
</div>
`;
const sortingOptions6 = ref([
{ text: "Product name ascending", value: 1 },
{ text: "Product name descending", value: 2 },
{ text: "Highest price", value: 3 },
{ text: "Lowest price", value: 4 },
]);
const sortingSelected6 = ref("");
const sort6 = ref({});
watch(
() => sortingSelected6.value,
(selected) => {
switch (selected) {
case 1: {
sort6.value.category = "product";
sort6.value.order = "asc";
break;
}
case 2: {
sort6.value.category = "product";
sort6.value.order = "desc";
break;
}
case 3: {
sort6.value.category = "price";
sort6.value.order = "desc";
break;
}
case 4: {
sort6.value.category = "price";
sort6.value.order = "asc";
break;
}
default: {
return;
}
}
}
);
return {
colorRadio6,
saleRadio6,
resetRadios6,
filterDataset6,
filterTemplate6,
sortingOptions6,
sortingSelected6,
sort6
};
},
};
</script>
<script setup lang="ts">
import { ref, watch } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBRadio,
MDBBtn,
MDBSelect
} from "mdb-vue-ui-kit";
interface FilterItem {
id: number;
color: string;
price: number;
sale: string;
product: string;
img?: string;
image?: string;
name: string;
}
interface Sorter {
category: string;
order: string;
}
const colorRadio6 = ref("");
const saleRadio6 = ref("");
const resetRadios6 = () => {
colorRadio6.value = "";
saleRadio6.value = "";
};
const filterDataset6 = ref([
{
id: 1,
color: "black",
price: 100,
sale: "no",
product: "Black Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
},
{
id: 2,
color: "black",
price: 100,
sale: "no",
product: "Black Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
},
{
id: 3,
color: "gray",
price: 80,
sale: "yes",
product: "Gray Jumper",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
},
{
id: 4,
color: "gray",
price: 80,
sale: "yes",
product: "Gray Jumper",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
},
{
id: 5,
color: "red",
price: 120,
sale: "yes",
product: "Red Hoodie",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.jpg",
},
{
id: 6,
color: "blue",
price: 90,
sale: "no",
product: "Blue Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.jpg",
},
]);
const filterTemplate6 = (item: FilterItem) => `
<div
class="col-md-4 mt-3 filter-item"
data-mdb-filter-color="${item.color}"
data-mdb-filter-sale="${item.sale}"
data-mdb-filter-animation="fade-in"
>
<div class="card shadow-2">
<img src="${item.img}" class="card-img-top" alt="..." />
<div class="card-body">
<h5 class="card-title">${item.product}</h5>
<p class="card-text">${item.price}$</p>
<a href="#" class="btn btn-primary ripple-surface">Buy now</a>
</div>
</div>
</div>
`;
const sortingOptions6 = ref([
{ text: "Product name ascending", value: 1 },
{ text: "Product name descending", value: 2 },
{ text: "Highest price", value: 3 },
{ text: "Lowest price", value: 4 },
]);
const sortingSelected6 = ref<string | number>("");
const sort6 = ref({} as Sorter);
watch(
() => sortingSelected6.value,
(selected) => {
switch (selected) {
case 1: {
sort6.value.category = "product";
sort6.value.order = "asc";
break;
}
case 2: {
sort6.value.category = "product";
sort6.value.order = "desc";
break;
}
case 3: {
sort6.value.category = "price";
sort6.value.order = "desc";
break;
}
case 4: {
sort6.value.category = "price";
sort6.value.order = "asc";
break;
}
default: {
return;
}
}
}
);
</script>
Customization - custom filter
Pass an arrow function as the value of the filter key at the filter object to define your custom filter.
<template>
<MDBFilter
:filters="{ price: { min: minRange, max: maxRange } }"
items=".filter-item"
class="row text-center mt-3"
>
<MDBRow class="justify-content-center mb-5">
<MDBCol md="12" class="mt-3 text-center">
<p class="fa-lg">Price:</p>
<MDBRange
label="Min"
v-model="defaultMinRange"
@change="handleMinRangeChange"
:min="80"
:max="120"
/>
<p id="min-val">Current: {{ minRange }}$</p>
<MDBRange
label="Max"
v-model="defaultMaxRange"
@change="handleMaxRangeChange"
:min="80"
:max="120"
/>
<p id="min-val">Current: {{ maxRange }}$</p>
</MDBCol>
</MDBRow>
<MDBRow class="text-center">
<MDBCol
md="4"
class="mt-3 filter-item"
data-mdb-filter-color="black"
data-mdb-filter-sale="no"
data-mdb-filter-price="100"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Black Jeans Jacket</MDBCardTitle>
<MDBCardText>100$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 filter-item"
data-mdb-filter-sale="yes"
data-mdb-filter-color="gray"
data-mdb-filter-price="80"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Gray Jumper</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">100$</span>
<span class="fw-bold fa-lg ps-1">80$</span></MDBCardText
>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 filter-item"
data-mdb-filter-color="blue"
data-mdb-filter-sale="no"
data-mdb-filter-price="90"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Blue Jeans Jacket</MDBCardTitle>
<MDBCardText>90$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 filter-item"
data-mdb-filter-color="red"
data-mdb-filter-sale="yes"
data-mdb-filter-price="120"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Red Hoodie</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">150$</span>
<span class="fw-bold fa-lg ps-1">120$</span></MDBCardText
>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 filter-item"
data-mdb-filter-color="black"
data-mdb-filter-sale="no"
data-mdb-filter-price="100"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Black Jeans Jacket</MDBCardTitle>
<MDBCardText>100$</MDBCardText>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
<MDBCol
md="4"
class="col-md-4 mt-3 filter-item"
data-mdb-filter-color="gray"
data-mdb-filter-sale="yes"
data-mdb-filter-price="80"
>
<MDBCard class="shadow-2">
<MDBCardImg
src="https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.jpg"
top
alt="..."
/>
<MDBCardBody>
<MDBCardTitle>Gray Jumper</MDBCardTitle>
<MDBCardText>
<span class="text-decoration-line-through">100$</span>
<span class="fw-bold fa-lg ps-1">80$</span></MDBCardText
>
<MDBBtn tag="a" color="primary">Buy now</MDBBtn>
</MDBCardBody>
</MDBCard>
</MDBCol>
</MDBRow>
</MDBFilter>
</template>
<script>
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBRange,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
} from "mdb-vue-ui-kit";
export default {
name: "App",
components: {
MDBFilter,
MDBRow,
MDBCol,
MDBRange,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
},
setup() {
const defaultMinRange = ref(80);
const defaultMaxRange = ref(120);
const minRange = ref(80);
const maxRange = ref(120);
const handleMinRangeChange = (event) => {
minRange.value = event.target.value;
};
const handleMaxRangeChange = (event) => {
maxRange.value = event.target.value;
};
return {
defaultMinRange,
defaultMaxRange,
minRange,
maxRange,
handleMinRangeChange,
handleMaxRangeChange,
};
},
};
</script>
<script setup lang="ts">
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBRange,
MDBCard,
MDBCardImg,
MDBCardBody,
MDBCardTitle,
MDBCardText,
MDBBtn,
} from "mdb-vue-ui-kit";
const defaultMinRange = ref(80);
const defaultMaxRange = ref(120);
const minRange = ref(80);
const maxRange = ref(120);
const handleMinRangeChange = (event: Event) => {
minRange.value = (event.target as HTMLInputElement).valueAsNumber;
};
const handleMaxRangeChange = (event: Event) => {
maxRange.value = (event.target as HTMLInputElement).valueAsNumber;
};
</script>
Custom sort
<template>
<MDBRow class="justify-content-center">
<MDBCol md="4" class="text-center">
<MDBBtn color="primary" @click="customSort('product', 'asc')">
Sort by product name ascending
</MDBBtn>
</MDBCol>
<MDBCol md="4" class="text-center">
<MDBBtn color="primary" @click="customSort('product', 'desc')">
Sort by product name descending
</MDBBtn>
</MDBCol>
</MDBRow>
<MDBFilter
:dataset="filterDataset7"
:template="filterTemplate7"
:sort="sort7"
items=".filter-item"
class="row text-center"
/>
</template>
<script>
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBBtn
} from "mdb-vue-ui-kit";
export default {
name: "App",
components: {
MDBFilter,
MDBRow,
MDBCol,
MDBBtn
},
setup() {
const sort7 = ref({});
const customSort = (category, order) => {
sort7.value.category = category;
sort7.value.order = order;
};
const filterDataset7 = ref([
{
id: 1,
color: "black",
price: 100,
sale: "no",
product: "Black Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
},
{
id: 2,
color: "black",
price: 100,
sale: "no",
product: "Black Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
},
{
id: 3,
color: "gray",
price: 80,
sale: "yes",
product: "Gray Jumper",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
},
{
id: 4,
color: "gray",
price: 80,
sale: "yes",
product: "Gray Jumper",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
},
{
id: 5,
color: "red",
price: 120,
sale: "yes",
product: "Red Hoodie",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.jpg",
},
{
id: 6,
color: "blue",
price: 90,
sale: "no",
product: "Blue Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.jpg",
},
]);
const filterTemplate7 = (item) => `
<div
class="col-md-4 mt-3 filter-item"
data-mdb-filter-color="${item.color}"
data-mdb-filter-sale="${item.sale}"
>
<div class="card shadow-2">
<img src="${item.img}" class="card-img-top" alt="..." />
<div class="card-body">
<h5 class="card-title">${item.product}</h5>
<p class="card-text">${item.price}$</p>
<a href="#" class="btn btn-primary ripple-surface">Buy now</a>
</div>
</div>
</div>
`;
return {
sort7,
customSort,
filterDataset7,
filterTemplate7,
};
},
};
</script>
<script setup lang="ts">
import { ref } from "vue";
import { MDBFilter } from "mdb-vue-filters";
import {
MDBRow,
MDBCol,
MDBBtn
} from "mdb-vue-ui-kit";
interface FilterItem {
id: number;
color: string;
price: number;
sale: string;
product: string;
img?: string;
image?: string;
name: string;
}
interface Sorter {
category: string;
order: string;
}
const sort7 = ref({} as Sorter);
const customSort = (category: string, order: string) => {
sort7.value.category = category;
sort7.value.order = order;
};
const filterDataset7 = ref([
{
id: 1,
color: "black",
price: 100,
sale: "no",
product: "Black Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
},
{
id: 2,
color: "black",
price: 100,
sale: "no",
product: "Black Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
},
{
id: 3,
color: "gray",
price: 80,
sale: "yes",
product: "Gray Jumper",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
},
{
id: 4,
color: "gray",
price: 80,
sale: "yes",
product: "Gray Jumper",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
},
{
id: 5,
color: "red",
price: 120,
sale: "yes",
product: "Red Hoodie",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.jpg",
},
{
id: 6,
color: "blue",
price: 90,
sale: "no",
product: "Blue Jeans Jacket",
img: "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.jpg",
},
]);
const filterTemplate7 = (item: FilterItem) => `
<div
class="col-md-4 mt-3 filter-item"
data-mdb-filter-color="${item.color}"
data-mdb-filter-sale="${item.sale}"
>
<div class="card shadow-2">
<img src="${item.img}" class="card-img-top" alt="..." />
<div class="card-body">
<h5 class="card-title">${item.product}</h5>
<p class="card-text">${item.price}$</p>
<a href="#" class="btn btn-primary ripple-surface">Buy now</a>
</div>
</div>
</div>
`;
</script>
Full screen example
<template>
<header>
<MDBNavbar expand="lg" light bg="white" position="sticky" container>
<MDBNavbarToggler @click="collapse = !collapse" target="#navbarSupportedContent"></MDBNavbarToggler>
<MDBNavbarBrand href="#">
<MDBIcon iconStyle="fab" icon="mdb" size="2x" alt="mdb logo" />
</MDBNavbarBrand>
<MDBCollapse v-model="collapse" id="navbarSupportedContent">
<MDBNavbarNav right>
<MDBNavbarItem to="/full-page-example" active class="my-auto">
<MDBBadge color="danger" rounded pill>1</MDBBadge>
<MDBIcon icon="shopping-cart" />
</MDBNavbarItem>
<MDBNavbarItem class="my-auto">
<!-- Navbar dropdown -->
<MDBDropdown class="nav-item" v-model="dropdown">
<MDBDropdownToggle tag="a" class="nav-link" @click="dropdown = !dropdown"><i
class="flag-united-kingdom flag m-0"></i>
</MDBDropdownToggle>
<MDBDropdownMenu>
<MDBDropdownItem href="#">Action</MDBDropdownItem>
<MDBDropdownItem href="#">Another Action</MDBDropdownItem>
<MDBDropdownItem href="#">Something else here</MDBDropdownItem>
</MDBDropdownMenu>
</MDBDropdown>
</MDBNavbarItem>
<MDBNavbarItem to="/full-page-example" active class="my-auto">Shop</MDBNavbarItem>
<MDBNavbarItem to="/full-page-example" active class="my-auto">Contact</MDBNavbarItem>
<MDBNavbarItem to="/full-page-example" active class="my-auto">Sign in</MDBNavbarItem>
<MDBNavbarItem to="/full-page-example" class="my-auto">
<MDBBtn outline="dark" rounded>Sign up</MDBBtn>
</MDBNavbarItem>
</MDBNavbarNav>
</MDBCollapse>
</MDBNavbar>
<div class="p-5 text-center bg-image" style="
background-image: url('https://mdbootstrap.com/img/Photos/Others/clothes(5)-crop.jpg');
height: 400px;
">
<div class="mask" style="background-color: rgba(0, 0, 0, 0.7)">
<div class="d-flex justify-content-center align-items-center h-100">
<div class="text-white">
<h1 class="mb-3">Shop</h1>
</div>
</div>
</div>
</div>
</header>
<main>
<MDBContainer class="mt-5">
<MDBRow>
<MDBCol md="4">
<section>
<h5>Filters</h5>
<section class="mb-4">
<h6 class="fw-bold mb-3">Condition</h6>
<MDBCheckbox v-model="condition.new" label="New" wrapperClass="mb-3"
labelClass="form-check-label text-uppercase small text-muted" />
<MDBCheckbox v-model="condition.used" label="Used" wrapperClass="mb-3"
labelClass="form-check-label text-uppercase small text-muted" />
<MDBCheckbox v-model="condition.collectible" label="Collectible" wrapperClass="mb-3"
labelClass="form-check-label text-uppercase small text-muted" />
<MDBCheckbox v-model="condition.renewed" label="Renewed" wrapperClass="mb-3"
labelClass="form-check-label text-uppercase small text-muted" />
</section>
<section class="mb-4">
<h6 class="fw-bold mb-3">Avg. Customer Review</h6>
<MDBRating v-model="rating">
<MDBRatingItem title="1" :index="1" />
<MDBRatingItem title="2" :index="2" />
<MDBRatingItem title="3" :index="3" />
<MDBRatingItem title="4" :index="4" />
<MDBRatingItem title="5" :index="5" />
</MDBRating>
</section>
<section class="mb-4">
<h6 class="fw-bold mb-3">Price</h6>
<MDBRadio name="price" v-model="price" value="under25" label="Under $25" wrapperClass="mb-3"
labelClass="form-check-label text-uppercase small text-muted" />
<MDBRadio name="price" v-model="price" value="25to50" label="$25 to $50" wrapperClass="mb-3"
labelClass="form-check-label text-uppercase small text-muted" />
<MDBRadio name="price" v-model="price" value="50to100" label="$50 to $100" wrapperClass="mb-3"
labelClass="form-check-label text-uppercase small text-muted" />
<MDBRadio name="price" v-model="price" value="100to200" label="$100 to $200" wrapperClass="mb-3"
labelClass="form-check-label text-uppercase small text-muted" />
<MDBRadio name="price" v-model="price" value="over200" label="$200 & above" wrapperClass="mb-3"
labelClass="form-check-label text-uppercase small text-muted" />
</section>
<section class="mb-4">
<h6 class="fw-bold mb-3">Size</h6>
<MDBCheckbox v-model="size['34']" label="34" wrapperClass="mb-3"
labelClass="form-check-label text-uppercase small text-muted" />
<MDBCheckbox v-model="size['36']" label="36" wrapperClass="mb-3"
labelClass="form-check-label text-uppercase small text-muted" />
<MDBCheckbox v-model="size['38']" label="38" wrapperClass="mb-3"
labelClass="form-check-label text-uppercase small text-muted" />
<MDBCheckbox v-model="size['40']" label="40" wrapperClass="mb-3"
labelClass="form-check-label text-uppercase small text-muted" />
</section>
<section class="mb-4">
<h6 class="fw-bold mb-3">Color</h6>
<MDBRadio inline label=" " wrapperClass="m-0 p-0 pe-3" labelClass="btn bg-white btn-rounded p-3"
name="colorButtonsRadio" v-model="color" value="white" hidden />
<MDBRadio inline label=" " wrapperClass="m-0 p-0 pe-3"
labelClass="btn bg-black opacity-50 btn-rounded p-3" name="colorButtonsRadio" v-model="color"
value="grey" hidden />
<MDBRadio inline label=" " wrapperClass="m-0 p-0 pe-3" labelClass="btn bg-black btn-rounded p-3"
name="colorButtonsRadio" v-model="color" value="black" hidden />
<MDBRadio inline label=" " wrapperClass="m-0 p-0 pe-3" labelClass="btn bg-primary btn-rounded p-3"
name="colorButtonsRadio" v-model="color" value="blue" hidden />
<MDBRadio inline label=" " wrapperClass="m-0 p-0 pe-3" labelClass="btn bg-danger btn-rounded p-3"
name="colorButtonsRadio" v-model="color" value="red" hidden />
<MDBRadio inline label=" " wrapperClass="m-0 p-0 pe-3" labelClass="btn bg-warning btn-rounded p-3"
name="colorButtonsRadio" v-model="color" value="orange" hidden />
</section>
</section>
</MDBCol>
<MDBCol md="8">
<MDBRow class="justify-content-center">
<MDBCol md="6" class="my-auto py-3">
<MDBSelect label="Sort" placeholder="Choose category" v-model:options="sortingOptions"
v-model:selected="sortingSelected" />
</MDBCol>
</MDBRow>
<MDBFilter class="row mb-4" :dataset="filterDataset" :template="filterTemplate" :filters="filters"
:sort="sort" items=".filter-item" />
</MDBCol>
</MDBRow>
</MDBContainer>
</main>
<footer class="bg-dark text-white text-center text-lg-left">
<!-- Socials -->
<div class="bg-primary text-center p-3">
<div class="row">
<div class="col-md-6">
<span class="font-weight-bold">Get connected with us on social networks!</span>
</div>
<div class="col-md-6">
<i class="fab fa-instagram"></i>
<i class="fab fa-linkedin-in ms-4"></i>
<i class="fab fa-twitter ms-4"></i>
<i class="fab fa-facebook-f ms-4"></i>
</div>
</div>
</div>
<!-- Socials -->
<!-- Grid container -->
<div class="container p-5">
<!--Grid row-->
<div class="row p-2">
<!--Grid column-->
<div class="col-md-3 mx-auto py-4">
<h5 class="text-uppercase">About me</h5>
<hr class="mb-4 mt-0" />
<p>
Here you can use rows and columns to organize your footer content.
Lorem ipsum dolor sit amet, consectetur adipisicing elit.
</p>
</div>
<!--Grid column-->
<!--Grid column-->
<div class="col-md-3 mx-auto py-4">
<h5 class="text-uppercase">Products</h5>
<hr class="mb-4 mt-0" />
<ul class="list-unstyled mb-0">
<li class="mb-2">
<a href="#!" class="text-white">MDBootstrap</a>
</li>
<li class="mb-2">
<a href="#!" class="text-white">MDWordPress</a>
</li>
<li class="mb-2">
<a href="#!" class="text-white">BrandFlow</a>
</li>
<li>
<a href="#!" class="text-white">Bootstrap Angular</a>
</li>
</ul>
</div>
<!--Grid column-->
<!--Grid column-->
<div class="col-md-3 mx-auto py-4">
<h5 class="text-uppercase">Useful links</h5>
<hr class="mb-4 mt-0" />
<ul class="list-unstyled">
<li class="mb-2">
<a href="#!" class="text-white">Your Account</a>
</li>
<li class="mb-2">
<a href="#!" class="text-white">Become an Affiliate</a>
</li>
<li class="mb-2">
<a href="#!" class="text-white">Shipping Rates</a>
</li>
<li>
<a href="#!" class="text-white">Help</a>
</li>
</ul>
</div>
<!--Grid column-->
<!--Grid column-->
<div class="col-md-3 mx-auto py-4">
<h5 class="text-uppercase">Contacts</h5>
<hr class="mb-4 mt-0" />
<ul class="list-unstyled">
<li class="mb-2">
<a href="#!" class="text-white"><i class="far fa-map mr-1"></i> New York, Avenue Street 10</a>
</li>
<li class="mb-2">
<a href="#!" class="text-white"><i class="fas fa-phone-alt mr-1"></i> 042 876 836 908</a>
</li>
<li class="mb-2">
<a href="#!" class="text-white"><i class="far fa-envelope mr-1"></i> company@example.com</a>
</li>
<li>
<a href="#!" class="text-white"><i class="far fa-clock mr-1"></i> Monday - Friday: 10-17</a>
</li>
</ul>
</div>
<!--Grid column-->
</div>
<!--Grid row-->
</div>
<!-- Grid container -->
<!-- Copyright -->
<div class="text-center p-3" style="background-color: rgba(0, 0, 0, 0.2)">
© 2020 Copyright:
<a class="text-white" href="https://mdbootstrap.com/">MDBootstrap.com</a>
</div>
<!-- Copyright -->
</footer>
</template>
<script>
import {
MDBNavbar,
MDBNavbarToggler,
MDBNavbarBrand,
MDBNavbarNav,
MDBNavbarItem,
MDBCollapse,
MDBDropdown,
MDBDropdownToggle,
MDBDropdownMenu,
MDBDropdownItem,
MDBIcon,
MDBBadge,
MDBBtn,
MDBContainer,
MDBRow,
MDBCol,
MDBCheckbox,
MDBRating,
MDBRatingItem,
MDBRadio,
MDBSelect,
} from "mdb-vue-ui-kit";
import MDBFilter from "@/components/MDBFilter";
import { ref, computed, watch } from "vue";
export default {
components: {
MDBNavbar,
MDBNavbarToggler,
MDBNavbarBrand,
MDBNavbarNav,
MDBNavbarItem,
MDBCollapse,
MDBDropdown,
MDBDropdownToggle,
MDBDropdownMenu,
MDBDropdownItem,
MDBIcon,
MDBBadge,
MDBBtn,
MDBContainer,
MDBRow,
MDBCol,
MDBCheckbox,
MDBRating,
MDBRatingItem,
MDBRadio,
MDBSelect,
MDBFilter,
},
setup() {
const collapse = ref(false);
const dropdown = ref(false);
const condition = ref({
new: false,
used: false,
collectible: false,
renewed: false,
});
const rating = ref(0);
const price = ref("");
const size = ref({
34: false,
36: false,
38: false,
40: false,
});
const color = ref("");
const parsedPrice = computed(() => {
if (price.value === "under25") {
return { max: 25 };
} else if (price.value === "25to50") {
return { min: 25, max: 50 };
} else if (price.value === "50to100") {
return { min: 50, max: 100 };
} else if (price.value === "100to200") {
return { min: 100, max: 200 };
} else if (price.value === "over200") {
return { min: 200 };
}
return "";
});
const filters = computed(() => ({
condition: condition.value,
rating: rating.value,
price: parsedPrice.value,
size: size.value,
color: color.value,
}));
const filterDataset = ref([]);
fetch("products.json")
.then((response) => response.json())
.then((data) => {
filterDataset.value = data;
});
const filterTemplate = (item) => `
<div
class="col-md-4 my-4 justify-content-center text-center filter-item"
data-mdb-filter-condition="${item.condition}"
data-mdb-filter-rating="${item.rating}"
data-mdb-filter-price="${item.price}"
data-mdb-filter-size="${item.size}"
data-mdb-filter-color="${item.color}"
data-mdb-filter-animation="fade-in"
>
<div class="bg-image hover-overlay hover-zoom hover-shadow">
<img src="${item.image}" class="img-fluid w-100" alt="..." style="height: 325px" />
<a href="#!">
<div class="mask rounded" style="background-color: rgba(66, 66, 66, 0.2);"></div>
</a>
</div>
<div class="pt-4">
<h5>${item.name}</h5>
<strong>$${item.price}</strong>
</div>
</div>
`;
const sortingOptions = ref([
{ text: "Best rating", value: 1 },
{ text: "Lowest price first", value: 2 },
{ text: "Highest price first", value: 3 },
]);
const sortingSelected = ref("");
const sort = ref({});
watch(
() => sortingSelected.value,
(selected) => {
switch (selected) {
case 1: {
sort.value.category = "rating";
sort.value.order = "desc";
break;
}
case 2: {
sort.value.category = "price";
sort.value.order = "asc";
break;
}
case 3: {
sort.value.category = "price";
sort.value.order = "desc";
break;
}
default: {
return;
}
}
}
);
return {
collapse,
dropdown,
condition,
rating,
price,
size,
color,
filters,
filterDataset,
filterTemplate,
sortingOptions,
sortingSelected,
sort,
};
},
};
</script>
<script setup lang="ts">
import {
MDBNavbar,
MDBNavbarToggler,
MDBNavbarBrand,
MDBNavbarNav,
MDBNavbarItem,
MDBCollapse,
MDBDropdown,
MDBDropdownToggle,
MDBDropdownMenu,
MDBDropdownItem,
MDBIcon,
MDBBadge,
MDBBtn,
MDBContainer,
MDBRow,
MDBCol,
MDBCheckbox,
MDBRating,
MDBRatingItem,
MDBRadio,
MDBSelect,
} from "mdb-vue-ui-kit";
import MDBFilter from "@/components/MDBFilter";
import { ref, computed, watch } from "vue";
interface FilterItem {
condition: string;
rating: string;
price: string;
size: string;
color: string;
name: string;
image: string;
}
interface Sorter {
category: string;
order: string;
}
const collapse = ref(false);
const dropdown = ref(false);
const condition = ref({
new: false,
used: false,
collectible: false,
renewed: false,
});
const rating = ref(0);
const price = ref("");
const size = ref({
34: false,
36: false,
38: false,
40: false,
});
const color = ref("");
const parsedPrice = computed(() => {
if (price.value === "under25") {
return { max: 25 };
} else if (price.value === "25to50") {
return { min: 25, max: 50 };
} else if (price.value === "50to100") {
return { min: 50, max: 100 };
} else if (price.value === "100to200") {
return { min: 100, max: 200 };
} else if (price.value === "over200") {
return { min: 200 };
}
return "";
});
const filters = computed(() => ({
condition: condition.value,
rating: rating.value,
price: parsedPrice.value,
size: size.value,
color: color.value,
}));
const filterDataset = ref([]);
fetch("products.json")
.then((response) => response.json())
.then((data) => {
filterDataset.value = data;
});
const filterTemplate = (item: FilterItem) => `
<div
class="col-md-4 my-4 justify-content-center text-center filter-item"
data-mdb-filter-condition="${item.condition}"
data-mdb-filter-rating="${item.rating}"
data-mdb-filter-price="${item.price}"
data-mdb-filter-size="${item.size}"
data-mdb-filter-color="${item.color}"
data-mdb-filter-animation="fade-in"
>
<div class="bg-image hover-overlay hover-zoom hover-shadow">
<img src="${item.image}" class="img-fluid w-100" alt="..." style="height: 325px" />
<a href="#!">
<div class="mask rounded" style="background-color: rgba(66, 66, 66, 0.2);"></div>
</a>
</div>
<div class="pt-4">
<h5>${item.name}</h5>
<strong>$${item.price}</strong>
</div>
</div>
`;
const sortingOptions = ref([
{ text: "Best rating", value: 1 },
{ text: "Lowest price first", value: 2 },
{ text: "Highest price first", value: 3 },
]);
const sortingSelected = ref<string | number>("");
const sort = ref({} as Sorter);
watch(
() => sortingSelected.value,
(selected) => {
switch (selected) {
case 1: {
sort.value.category = "rating";
sort.value.order = "desc";
break;
}
case 2: {
sort.value.category = "price";
sort.value.order = "asc";
break;
}
case 3: {
sort.value.category = "price";
sort.value.order = "desc";
break;
}
default: {
return;
}
}
}
);
</script>
[
{
"id": 1,
"category": "shirts",
"name": "Fantasy T-shirt",
"rating": 4,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["34", "36", "40"],
"condition": "new",
"color": "blue",
"price": 12.99,
"keywords": ["t-shirt", "sweatshitrt"],
"discount": 0,
"gender": "male"
},
{
"id": 2,
"category": "shirts",
"name": "Fantasy T-shirt",
"rating": 5,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["34", "36", "40", "44"],
"condition": "new",
"color": "red",
"price": 12.99,
"discount": 0,
"gender": "male"
},
{
"id": 3,
"category": "shirts",
"name": "Fantasy T-shirt",
"rating": 3,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["34", "36"],
"condition": "new",
"color": "grey",
"price": 40.99,
"discount": 10,
"gender": "male"
},
{
"id": 4,
"category": "jackets",
"name": "Denim Jacket",
"rating": 5,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"condition": "new",
"color": "grey",
"price": 40.99,
"discount": 0,
"gender": "unisex"
},
{
"id": 5,
"category": "jeans",
"name": "Ripped jeans",
"rating": 5,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/11.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["34", "36", "38", "40"],
"condition": "renewed",
"color": "blue",
"price": 20.99,
"discount": 5,
"gender": "female"
},
{
"id": 6,
"category": "jeans",
"name": "Boyfriend jeans",
"rating": 4,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/10.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": false,
"size": ["34", "36", "38", "40"],
"condition": "used",
"color": "blue",
"price": 20.99,
"discount": 5,
"gender": "female"
},
{
"id": 7,
"category": "shirts",
"name": "Ripped sweatshirt",
"rating": 4,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/7.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["34", "36", "38", "40"],
"condition": "collectible",
"color": "white",
"price": 29.99,
"discount": 5,
"gender": "female"
},
{
"id": 8,
"category": "shirts",
"name": "Longsleeve",
"rating": 4,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/8.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["40"],
"condition": "collectible",
"color": "black",
"price": 120.99,
"discount": 0,
"gender": "male"
},
{
"id": 8,
"category": "shirts",
"name": "Stripped sweatshirt",
"rating": 4,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/6.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["40", "38", "36"],
"condition": "new",
"color": "white",
"price": 32.99,
"discount": 10,
"gender": "female"
},
{
"id": 9,
"category": "trousers",
"name": "Red chinos",
"rating": 5,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/5.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["40", "38", "36"],
"condition": "new",
"color": "red",
"price": 62.99,
"discount": 10,
"gender": "female"
},
{
"id": 10,
"category": "coats",
"name": "Camel coat",
"rating": 5,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/4.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["40", "38", "36"],
"condition": "used",
"color": "brown",
"price": 62.99,
"discount": 10,
"gender": "female"
},
{
"id": 11,
"category": "jeans",
"name": "Blue jeans",
"rating": 5,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/3.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["40", "38", "36"],
"condition": "new",
"color": "blue",
"price": 42.99,
"discount": 0,
"gender": "female"
},
{
"id": 12,
"category": "shirts",
"name": "Orange T-shirt",
"rating": 3,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/3.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["40", "38", "36"],
"condition": "new",
"color": "orange",
"price": 12.99,
"discount": 0,
"gender": "female"
},
{
"id": 13,
"category": "skirts",
"name": "Ballerina skirt",
"rating": 4,
"image": "https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/2.jpg",
"description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
"available": true,
"size": ["38", "36"],
"condition": "collectible",
"color": "white",
"price": 12.99,
"discount": 0,
"gender": "female"
}
]
Filters - API
Import
<script>
import { MDBFilter } from "mdb-vue-filters";
</script>
Properties
| Name | Type | Default | Description |
|---|---|---|---|
dataset
|
Object | {} |
Allows you to set specific dataset object |
filters
|
Object | {} |
Allows you to set filtering rules |
items
|
String | "" |
Defines items query selector |
noFoundMessage
|
String | "<h3 class='text-center mt-5'>No items found</h3>" |
Defines message if no results |
noFoundMessageElement
|
String | "div" |
Defines message wrapper if no results |
sort
|
Object | {} |
Defines sorting rules |
tag
|
String | "div" |
Defines wrapper element |
template
|
Function | |
Defines template function |
Events
| Name | Description |
|---|---|
update
|
This event fires immediately after any change. It returns an item list. |
For example, to listen on file change add an event
<template>
<MDBFilter @update="handleUpdate" />
</template>

Filters

React 5 Filters plugin

Filters are the best way to select data that meets your requirements - they affect your search results by filtrating and sorting the dataset you pass to our component.

Note: Read the API tab to find all available options and advanced customization

View full screen demo

Basic example - JSX Elements

Use filterData and data properties to define elements to filter. This is required for proper component initialization.

Add filters, filterOptions and handlers for them to every input you want to use as a filter.

Note: You must have at least one filtrable element for a component to work properly.

Filter: Color
Filter: Sale
Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
Blue Jeans Jacket
Blue Jeans Jacket

90$

Buy now
Red Hoodie
Red Hoodie

150$ 120$

Buy now
Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
import React, { useState } from 'react';
import { MDBCol, MDBRow, MDBRadio, MDBBtn, MDBCardText, MDBCardBody, MDBCard } from 'mdb-react-ui-kit';
import { MDBFilters } from 'mdb-react-filters';

export const exampleData = [
  {
    name: 'Black Jeans Jacket',
    price: 100,
    color: 'black',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
  },
  {
    name: 'Gray Jumper',
    oldPrice: 100,
    price: 80,
    color: 'gray',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
  },

  {
    name: 'Blue Jeans Jacket',
    price: 90,
    color: 'blue',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
  },
  {
    name: 'Red Hoodie',
    oldPrice: 150,
    price: 120,
    color: 'red',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
  },
  {
    name: 'Black Jeans Jacket',
    price: 100,
    color: 'black',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
  },
  {
    name: 'Gray Jumper',
    oldPrice: 100,
    price: 80,
    color: 'gray',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
  },
];

export default function App() {
  const [basicFilters, setBasicFilters] = useState({ color: '', sale: '' });
  const [basicData, setBasicData] = useState(exampleData);

  const onChangeBasic = (e) => {
    setBasicFilters({ ...basicFilters, [e.target.name]: e.target.value });
  };

  return (
    <section className='pb-4'>
      <div className='bg-white border rounded-5'>
        <section className='w-100 p-4 justify-content-center'>
          <MDBRow className='justify-content-center'>
            <MDBCol md='6'>
              <span className='fa-lg'>Filter: Color</span>

              <MDBRadio
                name='color'
                onChange={onChangeBasic}
                value='black'
                checked={basicFilters.color === 'black'}
                label='Black'
                wrapperClass='mt-3'
              />

              <MDBRadio
                name='color'
                value='red'
                onChange={onChangeBasic}
                checked={basicFilters.color === 'red'}
                label='Red'
              />

              <MDBRadio
                name='color'
                value='blue'
                onChange={onChangeBasic}
                checked={basicFilters.color === 'blue'}
                label='Blue'
              />

              <MDBRadio
                name='color'
                value='gray'
                onChange={onChangeBasic}
                checked={basicFilters.color === 'gray'}
                label='Gray'
              />
            </MDBCol>

            <MDBCol md='6'>
              <span className='fa-lg mb-5'>Filter: Sale</span>

              <MDBRadio
                name='sale'
                onChange={onChangeBasic}
                checked={basicFilters.sale === 'yes'}
                value='yes'
                label='Yes'
                wrapperClass='mt-3'
              />

              <MDBRadio
                name='sale'
                onChange={onChangeBasic}
                checked={basicFilters.sale === 'no'}
                value='no'
                label='No'
              />

              <MDBBtn
                className='mt-3'
                style={{ minWidth: '156px' }}
                onClick={() => setBasicFilters({ color: '', sale: '' })}
              >
                Clear all filters
              </MDBBtn>
            </MDBCol>
          </MDBRow>
          <MDBFilters
            filterData={setBasicData}
            data={exampleData}
            filters={basicFilters}
            filterOptions={[
              { type: 'radio', key: 'color' },
              { type: 'radio', key: 'sale' },
            ]}
          >
            {basicData.map((item, i) => (
              <MDBCol key={i} md='4' className='mt-3 basic-example-item'>
                <MDBCard className='card shadow-2'>
                  <img src={item.img} className='card-img-top' alt='...' />

                  <MDBCardBody>
                    <h5 className='card-title'>{item.name}</h5>
                    {item.sale === 'yes' ? (
                      <MDBCardText>
                        <span className='text-decoration-line-through'>{item.oldPrice}$</span>{' '}
                        <span className='fw-bold fa-lg'>{item.price}$</span>
                      </MDBCardText>
                    ) : (
                      <MDBCardText className='card-text'>{item.price}$</MDBCardText>
                    )}

                    <a href='#' className='btn btn-primary ripple-surface'>
                      Buy now
                    </a>
                  </MDBCardBody>
                </MDBCard>
              </MDBCol>
            ))}
          </MDBFilters>
        </section>
      </div>
    </section>
  );
}

Checkbox example

Note: If there is more than one option, the result of filtering will show items that match both of them.

Filter: Color
Filter: Sale
Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
Blue Jeans Jacket
Blue Jeans Jacket

90$

Buy now
Red Hoodie
Red Hoodie

150$ 120$

Buy now
Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
import React, { useState } from 'react';
import { MDBCol, MDBRow, MDBCheckbox, MDBBtn, MDBCardText, MDBCardBody, MDBCard } from 'mdb-react-ui-kit';
import { MDBFilters } from 'mdb-react-filters';

export const exampleData = [
  {
    name: 'Black Jeans Jacket',
    price: 100,
    color: 'black',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
  },
  {
    name: 'Gray Jumper',
    oldPrice: 100,
    price: 80,
    color: 'gray',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
  },

  {
    name: 'Blue Jeans Jacket',
    price: 90,
    color: 'blue',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
  },
  {
    name: 'Red Hoodie',
    oldPrice: 150,
    price: 120,
    color: 'red',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
  },
  {
    name: 'Black Jeans Jacket',
    price: 100,
    color: 'black',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
  },
  {
    name: 'Gray Jumper',
    oldPrice: 100,
    price: 80,
    color: 'gray',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
  },
];

export default function App() {
  const [checkboxFilters, setCheckboxFilters] = useState({
    color: [],
    sale: [],
  });

  const [checkboxData, setCheckboxData] = useState(exampleData);

  const onChangeCheckbox = (e: { target: { name, value } }) => {
    const containsValue = checkboxFilters[e.target.name].includes(e.target.value);

    if (containsValue) {
      setCheckboxFilters({
        ...checkboxFilters,
        [e.target.name]: checkboxFilters[e.target.name].filter((element) => element !== e.target.value),
      });
    } else {
      const newArray = [...checkboxFilters[e.target.name], e.target.value];

      setCheckboxFilters({ ...checkboxFilters, [e.target.name]: newArray });
    }
  };

  return (
    <section className='pb-4'>
      <div className='bg-white border rounded-5'>
        <section className='w-100 p-4 justify-content-center'>
          <MDBRow className='justify-content-center'>
            <MDBCol md='6'>
              <span className='fa-lg'>Filter: Color</span>

              <MDBCheckbox
                name='color'
                onChange={onChangeCheckbox}
                value='black'
                checked={checkboxFilters.color.includes('black')}
                label='Black'
                wrapperClass='mt-3'
              />

              <MDBCheckbox
                name='color'
                value='red'
                onChange={onChangeCheckbox}
                checked={checkboxFilters.color.includes('red')}
                label='Red'
              />

              <MDBCheckbox
                name='color'
                value='blue'
                onChange={onChangeCheckbox}
                checked={checkboxFilters.color.includes('blue')}
                label='Blue'
              />

              <MDBCheckbox
                name='color'
                value='gray'
                onChange={onChangeCheckbox}
                checked={checkboxFilters.color.includes('gray')}
                label='Gray'
              />
            </MDBCol>

            <MDBCol md='6'>
              <span className='fa-lg mb-5'>Filter: Sale</span>

              <MDBCheckbox
                name='sale'
                onChange={onChangeCheckbox}
                checked={checkboxFilters.sale.includes('yes')}
                value='yes'
                label='Yes'
                wrapperClass='mt-3'
              />

              <MDBCheckbox
                name='sale'
                onChange={onChangeCheckbox}
                checked={checkboxFilters.sale.includes('no')}
                value='no'
                label='No'
              />

              <MDBBtn
                className='mt-3'
                style={{ minWidth: '156px' }}
                onClick={() => setCheckboxFilters({ color: [], sale: [] })}
              >
                Clear all filters
              </MDBBtn>
            </MDBCol>
          </MDBRow>
          <MDBFilters
            filterData={setCheckboxData}
            data={exampleData}
            filters={checkboxFilters}
            filterOptions={[
              { type: 'checkbox', key: 'color' },
              { type: 'checkbox', key: 'sale' },
            ]}
          >
            {checkboxData.map((item, i) => (
              <MDBCol key={i} md='4' className='mt-3 basic-example-item'>
                <MDBCard className='card shadow-2'>
                  <img src={item.img} className='card-img-top' alt='...' />

                  <MDBCardBody>
                    <h5 className='card-title'>{item.name}</h5>
                    {item.sale === 'yes' ? (
                      <MDBCardText>
                        <span className='text-decoration-line-through'>{item.oldPrice}$</span>{' '}
                        <span className='fw-bold fa-lg'>{item.price}$</span>
                      </MDBCardText>
                    ) : (
                      <MDBCardText className='card-text'>{item.price}$</MDBCardText>
                    )}

                    <a href='#' className='btn btn-primary ripple-surface'>
                      Buy now
                    </a>
                  </MDBCardBody>
                </MDBCard>
              </MDBCol>
            ))}
          </MDBFilters>
        </section>
      </div>
    </section>
  );
}

Color example

Filter: Color

Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
Blue Jeans Jacket
Blue Jeans Jacket

90$

Buy now
Red Hoodie
Red Hoodie

150$ 120$

Buy now
Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
import React, { useEffect, useState } from 'react';
import { MDBCol, MDBRow, MDBRadio, MDBBtn, MDBCardText, MDBCardBody, MDBCard, MDBRipple } from 'mdb-react-ui-kit';
import { MDBFilters } from 'mdb-react-filters';

export const exampleData = [
  {
    name: 'Black Jeans Jacket',
    price: 100,
    color: 'black',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
  },
  {
    name: 'Gray Jumper',
    oldPrice: 100,
    price: 80,
    color: 'gray',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
  },

  {
    name: 'Blue Jeans Jacket',
    price: 90,
    color: 'blue',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
  },
  {
    name: 'Red Hoodie',
    oldPrice: 150,
    price: 120,
    color: 'red',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
  },
  {
    name: 'Black Jeans Jacket',
    price: 100,
    color: 'black',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
  },
  {
    name: 'Gray Jumper',
    oldPrice: 100,
    price: 80,
    color: 'gray',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
  },
];

export default function App() {
  const [colorFilters, setColorFilters] = useState({ color: '' });
  const [colorData, setColorData] = useState(exampleData);

  const onChangeColor = (e) => {
    setColorFilters({ ...colorFilters, [e.target.name]: e.target.value });
  };

  return (
    <section className='pb-4'>
      <div className='bg-white border rounded-5'>
        <section className='w-100 p-4 justify-content-center'>
          <MDBRow className='justify-content-center'>
            <MDBCol className='text-center mb-3' md='12'>
              <p className='fa-lg mb-4'>Filter: Color</p>
              <div className='form-check form-check-inline'>
                <input
                  onChange={onChangeColor}
                  checked={colorFilters.color === 'red'}
                  className='btn-check'
                  type='radio'
                  name='color'
                  id='colorRadio1'
                  value='red'
                />

                <MDBRipple
                  rippleTag='label'
                  className='btn bg-danger btn-rounded p-4 '
                  htmlFor='colorRadio1'
                  style={{ minWidth: '48px' }}
                ></MDBRipple>
              </div>

              <div className='form-check form-check-inline'>
                <input
                  onChange={onChangeColor}
                  checked={colorFilters.color === 'blue'}
                  className='btn-check'
                  type='radio'
                  name='color'
                  id='colorRadio2'
                  value='blue'
                />
                <MDBRipple
                  rippleTag='label'
                  className='btn bg-primary btn-rounded p-4 '
                  htmlFor='colorRadio2'
                  style={{ minWidth: '48px' }}
                ></MDBRipple>
              </div>

              <div className='form-check form-check-inline'>
                <input
                  onChange={onChangeColor}
                  checked={colorFilters.color === 'black'}
                  className='btn-check'
                  type='radio'
                  name='color'
                  id='colorRadio3'
                  value='black'
                />
                <MDBRipple
                  rippleTag='label'
                  className='btn bg-dark text-white btn-rounded p-4 '
                  htmlFor='colorRadio3'
                  style={{ minWidth: '48px' }}
                ></MDBRipple>
              </div>

              <div className='form-check form-check-inline'>
                <input
                  onChange={onChangeColor}
                  checked={colorFilters.color === 'gray'}
                  className='btn-check'
                  type='radio'
                  name='color'
                  id='colorRadio4'
                  value='gray'
                />
                <MDBRipple
                  rippleTag='label'
                  className='btn btn-rounded p-4 '
                  htmlFor='colorRadio4'
                  style={{ backgroundColor: 'rgb(189, 189, 189)', minWidth: '48px' }}
                ></MDBRipple>
              </div>
            </MDBCol>
            <MDBCol md='12' className='text-center my-3'>
              <MDBBtn onClick={() => setColorFilters({ color: '' })} style={{ minWidth: '155px' }}>
                Clear all filters
              </MDBBtn>
            </MDBCol>
          </MDBRow>
          <MDBFilters
            filterData={setColorData}
            data={exampleData}
            filters={colorFilters}
            filterOptions={[{ type: 'radio', key: 'color' }]}
          >
            {colorData.map((item, i) => (
              <MDBCol key={i} md='4' className='mt-3 color-example-item'>
                <MDBCard className='card shadow-2'>
                  <img src={item.img} className='card-img-top' alt='...' />

                  <MDBCardBody>
                    <h5 className='card-title'>{item.name}</h5>
                    {item.sale === 'yes' ? (
                      <MDBCardText>
                        <span className='text-decoration-line-through'>{item.oldPrice}$</span>{' '}
                        <span className='fw-bold fa-lg'>{item.price}$</span>
                      </MDBCardText>
                    ) : (
                      <MDBCardText className='card-text'>{item.price}$</MDBCardText>
                    )}

                    <a href='#' className='btn btn-primary ripple-surface'>
                      Buy now
                    </a>
                  </MDBCardBody>
                </MDBCard>
              </MDBCol>
            ))}
          </MDBFilters>
        </section>
      </div>
    </section>
  );
}

Size example

Filter: Size
Filter: Sale
Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
Blue Jeans Jacket
Blue Jeans Jacket

90$

Buy now
Red Hoodie
Red Hoodie

150$ 120$

Buy now
Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
import React, { useState } from 'react';
import { MDBCol, MDBRow, MDBCheckbox, MDBBtn, MDBCardText, MDBCardBody, MDBCard, MDBRadio } from 'mdb-react-ui-kit';
import { MDBFilters } from 'mdb-react-filters';

const sizeData = [
  {
    name: 'Black Jeans Jacket',
    price: 100,
    color: 'black',
    size: '42',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
  },
  {
    name: 'Gray Jumper',
    oldPrice: 100,
    price: 80,
    color: 'gray',
    size: '36',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
  },

  {
    name: 'Blue Jeans Jacket',
    price: 90,
    color: 'blue',
    size: '42',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
  },
  {
    name: 'Red Hoodie',
    oldPrice: 150,
    price: 120,
    color: 'red',
    size: '40',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
  },
  {
    name: 'Black Jeans Jacket',
    price: 100,
    color: 'black',
    size: '38',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
  },
  {
    name: 'Gray Jumper',
    oldPrice: 100,
    price: 80,
    color: 'gray',
    size: '36',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
  },
];

export default function App() {
  const [sizeFilters, setSizeFilters] = useState({
    size: [],
    sale: '',
  });

  const [checkboxData, setCheckboxData] = useState(sizeData);

  const onChangeCheckbox = (e: { target: { name, value } }) => {
    const containsValue = sizeFilters[e.target.name].includes(e.target.value);

    if (containsValue) {
      setSizeFilters({
        ...sizeFilters,
        [e.target.name]: sizeFilters.size.filter((element) => element !== e.target.value),
      });
    } else {
      const newArray = [...sizeFilters.size, e.target.value];

      setSizeFilters({ ...sizeFilters, [e.target.name]: newArray });
    }
  };

  const onChangeRadio = (e) => {
    setSizeFilters({ ...sizeFilters, [e.target.name]: e.target.value });
  };

  return (
    <section className='pb-4'>
      <div className='bg-white border rounded-5'>
        <section className='w-100 p-4 justify-content-center'>
          <MDBRow className='justify-content-center'>
            <MDBCol md='6'>
              <span className='fa-lg'>Filter: Color</span>

              <MDBCheckbox
                name='size'
                onChange={onChangeCheckbox}
                value='36'
                checked={sizeFilters.size.includes('36')}
                label='36'
                wrapperClass='mt-3'
              />

              <MDBCheckbox
                name='size'
                value='38'
                onChange={onChangeCheckbox}
                checked={sizeFilters.size.includes('38')}
                label='38'
              />

              <MDBCheckbox
                name='size'
                value='40'
                onChange={onChangeCheckbox}
                checked={sizeFilters.size.includes('40')}
                label='40'
              />

              <MDBCheckbox
                name='size'
                value='42'
                onChange={onChangeCheckbox}
                checked={sizeFilters.size.includes('42')}
                label='42'
              />
            </MDBCol>

            <MDBCol md='6'>
              <span className='fa-lg mb-5'>Filter: Sale</span>

              <MDBRadio
                name='sale'
                onChange={onChangeRadio}
                checked={sizeFilters.sale === 'yes'}
                value='yes'
                label='Yes'
                wrapperClass='mt-3'
              />

              <MDBRadio
                name='sale'
                onChange={onChangeRadio}
                checked={sizeFilters.sale === 'no'}
                value='no'
                label='No'
              />

              <MDBBtn
                className='mt-3'
                style={{ minWidth: '156px' }}
                onClick={() => setSizeFilters({ size: [], sale: '' })}
              >
                Clear all filters
              </MDBBtn>
            </MDBCol>
          </MDBRow>
          <MDBFilters
            filterData={setCheckboxData}
            data={sizeData}
            filters={sizeFilters}
            filterOptions={[
              { type: 'checkbox', key: 'size' },
              { type: 'radio', key: 'sale' },
            ]}
          >
            {checkboxData.map((item, i) => (
              <MDBCol key={i} md='4' className='mt-3 basic-example-item'>
                <MDBCard className='card shadow-2'>
                  <img src={item.img} className='card-img-top' alt='...' />

                  <MDBCardBody>
                    <h5 className='card-title'>{item.name}</h5>
                    {item.sale === 'yes' ? (
                      <MDBCardText>
                        <span className='text-decoration-line-through'>{item.oldPrice}$</span>{' '}
                        <span className='fw-bold fa-lg'>{item.price}$</span>
                      </MDBCardText>
                    ) : (
                      <MDBCardText className='card-text'>{item.price}$</MDBCardText>
                    )}

                    <a href='#' className='btn btn-primary ripple-surface'>
                      Buy now
                    </a>
                  </MDBCardBody>
                </MDBCard>
              </MDBCol>
            ))}
          </MDBFilters>
        </section>
      </div>
    </section>
  );
}

Animations with DOM Elements

Wrap filtrable elements in MDBAnimation component to animate them. The full list of available options you can find here.

Filter: Color
Filter: Sale
Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
Blue Jeans Jacket
Blue Jeans Jacket

90$

Buy now
Red Hoodie
Red Hoodie

150$ 120$

Buy now
Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
import React, { useEffect, useState } from 'react';
import { MDBCol, MDBRow, MDBRadio, MDBBtn, MDBCardText, MDBCardBody, MDBCard, MDBAnimation } from 'mdb-react-ui-kit';
import { MDBFilters } from 'mdb-react-filters';

const exampleData = [
  {
    name: 'Black Jeans Jacket',
    price: 100,
    color: 'black',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
  },
  {
    name: 'Gray Jumper',
    oldPrice: 100,
    price: 80,
    color: 'gray',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
  },

  {
    name: 'Blue Jeans Jacket',
    price: 90,
    color: 'blue',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
  },
  {
    name: 'Red Hoodie',
    oldPrice: 150,
    price: 120,
    color: 'red',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
  },
  {
    name: 'Black Jeans Jacket',
    price: 100,
    color: 'black',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
  },
  {
    name: 'Gray Jumper',
    oldPrice: 100,
    price: 80,
    color: 'gray',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
  },
];

export default function App() {
  const [basicFilters, setBasicFilters] = useState({ color: '', sale: '' });
  const [basicData, setBasicData] = useState(exampleData);

  const onChangeBasic = (e) => {
    setBasicFilters({ ...basicFilters, [e.target.name]: e.target.value });
  };

  return (
    <section className='pb-4'>
      <div className='bg-white border rounded-5'>
        <section className='w-100 p-4 justify-content-center'>
          <MDBRow className='justify-content-center'>
            <MDBCol md='6'>
              <span className='fa-lg'>Filter: Color</span>

              <MDBRadio
                name='color'
                onChange={onChangeBasic}
                value='black'
                checked={basicFilters.color === 'black'}
                label='Black'
                wrapperClass='mt-3'
              />

              <MDBRadio
                name='color'
                value='red'
                onChange={onChangeBasic}
                checked={basicFilters.color === 'red'}
                label='Red'
              />

              <MDBRadio
                name='color'
                value='blue'
                onChange={onChangeBasic}
                checked={basicFilters.color === 'blue'}
                label='Blue'
              />

              <MDBRadio
                name='color'
                value='gray'
                onChange={onChangeBasic}
                checked={basicFilters.color === 'gray'}
                label='Gray'
              />
            </MDBCol>

            <MDBCol md='6'>
              <span className='fa-lg mb-5'>Filter: Sale</span>

              <MDBRadio
                name='sale'
                onChange={onChangeBasic}
                checked={basicFilters.sale === 'yes'}
                value='yes'
                label='Yes'
                wrapperClass='mt-3'
              />

              <MDBRadio
                name='sale'
                onChange={onChangeBasic}
                checked={basicFilters.sale === 'no'}
                value='no'
                label='No'
              />

              <MDBBtn
                className='mt-3'
                style={{ minWidth: '156px' }}
                onClick={() => setBasicFilters({ color: '', sale: '' })}
              >
                Clear all filters
              </MDBBtn>
            </MDBCol>
          </MDBRow>
          <MDBFilters
            filterData={setBasicData}
            data={exampleData}
            filters={basicFilters}
            filterOptions={[
              { type: 'radio', key: 'color' },
              { type: 'radio', key: 'sale' },
            ]}
          >
            {basicData.map((item, i) => (
              <MDBCol key={i} md='4' className='mt-3 basic-example-item'>
                <MDBAnimation key={Math.random()} animation='fade-in' start='onLoad' tag='div'>
                  <MDBCard className='card shadow-2'>
                    <img src={item.img} className='card-img-top' alt='...' />

                    <MDBCardBody>
                      <h5 className='card-title'>{item.name}</h5>
                      {item.sale === 'yes' ? (
                        <MDBCardText>
                          <span className='text-decoration-line-through'>{item.oldPrice}$</span>{' '}
                          <span className='fw-bold fa-lg'>{item.price}$</span>
                        </MDBCardText>
                      ) : (
                        <MDBCardText className='card-text'>{item.price}$</MDBCardText>
                      )}

                      <a href='#' className='btn btn-primary ripple-surface'>
                        Buy now
                      </a>
                    </MDBCardBody>
                  </MDBCard>
                </MDBAnimation>
              </MDBCol>
            ))}
          </MDBFilters>
        </section>
      </div>
    </section>
  );
}

Filter and sort

Filter: Color
Filter: Sale
Choose category
import React, { useEffect, useState } from 'react';
import { MDBCol, MDBRow, MDBRadio, MDBBtn, MDBCardText, MDBCardBody, MDBCard, MDBSelect } from 'mdb-react-ui-kit';
import { MDBFilters } from 'mdb-react-filters';

const exampleData = [
  {
    name: 'Black Jeans Jacket',
    price: 100,
    color: 'black',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
  },
  {
    name: 'Gray Jumper',
    oldPrice: 100,
    price: 80,
    color: 'gray',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
  },

  {
    name: 'Blue Jeans Jacket',
    price: 90,
    color: 'blue',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
  },
  {
    name: 'Red Hoodie',
    oldPrice: 150,
    price: 120,
    color: 'red',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
  },
  {
    name: 'Black Jeans Jacket',
    price: 100,
    color: 'black',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
  },
  {
    name: 'Gray Jumper',
    oldPrice: 100,
    price: 80,
    color: 'gray',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
  },
];

export default function App() {
  const [basicFilters, setBasicFilters] = useState({ color: '', sale: '' });
  const [basicData, setBasicData] = useState(exampleData);
  const [sort, setSort] = useState({ sortProperty: '', order: 'asc' });

  const onChangeBasic = (e) => {
    setBasicFilters({ ...basicFilters, [e.target.name]: e.target.value });
  };

  const handleGetValue = (e) => {
    const value = e;

    if (value === 1) {
      setSort({ sortProperty: 'name', order: 'asc' });
    }

    if (value === 2) {
      setSort({ sortProperty: 'name', order: 'desc' });
    }

    if (value === 3) {
      setSort({ sortProperty: 'price', order: 'desc' });
    }

    if (value === 4) {
      setSort({ sortProperty: 'price', order: 'asc' });
    }
  };

  return (
    <section className='pb-4'>
      <div className='bg-white border rounded-5'>
        <section className='w-100 p-4 justify-content-center'>
          <MDBRow className='justify-content-center'>
            <MDBCol md='6'>
              <span className='fa-lg'>Filter: Color</span>

              <MDBRadio
                name='color'
                onChange={onChangeBasic}
                value='black'
                checked={basicFilters.color === 'black'}
                label='Black'
                wrapperClass='mt-3'
              />

              <MDBRadio
                name='color'
                value='red'
                onChange={onChangeBasic}
                checked={basicFilters.color === 'red'}
                label='Red'
              />

              <MDBRadio
                name='color'
                value='blue'
                onChange={onChangeBasic}
                checked={basicFilters.color === 'blue'}
                label='Blue'
              />

              <MDBRadio
                name='color'
                value='gray'
                onChange={onChangeBasic}
                checked={basicFilters.color === 'gray'}
                label='Gray'
              />
            </MDBCol>

            <MDBCol md='6'>
              <span className='fa-lg mb-5'>Filter: Sale</span>

              <MDBRadio
                name='sale'
                onChange={onChangeBasic}
                checked={basicFilters.sale === 'yes'}
                value='yes'
                label='Yes'
                wrapperClass='mt-3'
              />

              <MDBRadio
                name='sale'
                onChange={onChangeBasic}
                checked={basicFilters.sale === 'no'}
                value='no'
                label='No'
              />

              <MDBBtn
                className='mt-3'
                style={{ minWidth: '156px' }}
                onClick={() => setBasicFilters({ color: '', sale: '' })}
              >
                Clear all filters
              </MDBBtn>
            </MDBCol>
            <MDBCol md='8' className='my-5'>
              <MDBSelect
                getSelectedValue={handleGetValue}
                data={[
                  { text: 'Choose category', value: '', disabled: true },
                  { text: 'Product name ascending', value: 1, selected: true },
                  { text: 'Product name descending', value: 2 },
                  { text: 'Highest price', value: 3 },
                  { text: 'Lowest price', value: 4 },
                ]}
              />
            </MDBCol>
          </MDBRow>
          <MDBFilters
            filteredData={basicData}
            filterData={setBasicData}
            sortOptions={sort}
            data={exampleData}
            filters={basicFilters}
            filterOptions={[
              { type: 'radio', key: 'color' },
              { type: 'radio', key: 'sale' },
            ]}
          >
            {basicData.map((item, i) => (
              <MDBCol key={i} md='4' className='mt-3 basic-example-item'>
                <MDBCard className='card shadow-2'>
                  <img src={item.img} className='card-img-top' alt='...' />

                  <MDBCardBody>
                    <h5 className='card-title'>{item.name}</h5>
                    {item.sale === 'yes' ? (
                      <MDBCardText>
                        <span className='text-decoration-line-through'>{item.oldPrice}$</span>{' '}
                        <span className='fw-bold fa-lg'>{item.price}$</span>
                      </MDBCardText>
                    ) : (
                      <MDBCardText className='card-text'>{item.price}$</MDBCardText>
                    )}

                    <a href='#' className='btn btn-primary ripple-surface'>
                      Buy now
                    </a>
                  </MDBCardBody>
                </MDBCard>
              </MDBCol>
            ))}
          </MDBFilters>
        </section>
      </div>
    </section>
  );
}

Customization - custom filter

Price:

Current: 80$

Current: 120$

Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
Blue Jeans Jacket
Blue Jeans Jacket

90$

Buy now
Red Hoodie
Red Hoodie

150$ 120$

Buy now
Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
import React, { useEffect, useState } from 'react';
import { MDBCol, MDBRow, MDBRadio, MDBBtn, MDBCardText, MDBCardBody, MDBCard, MDBRange } from 'mdb-react-ui-kit';
import { MDBFilters } from 'mdb-react-filters';

const exampleData = [
  {
    name: 'Black Jeans Jacket',
    price: 100,
    color: 'black',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
  },
  {
    name: 'Gray Jumper',
    oldPrice: 100,
    price: 80,
    color: 'gray',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
  },

  {
    name: 'Blue Jeans Jacket',
    price: 90,
    color: 'blue',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
  },
  {
    name: 'Red Hoodie',
    oldPrice: 150,
    price: 120,
    color: 'red',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
  },
  {
    name: 'Black Jeans Jacket',
    price: 100,
    color: 'black',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
  },
  {
    name: 'Gray Jumper',
    oldPrice: 100,
    price: 80,
    color: 'gray',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
  },
];

export default function App() {
  const [customFilters, setCustomFilters] = useState({ min: 80, max: 120 });
  const [basicData, setBasicData] = useState(exampleData);

  const onChange = (e) => {
    setCustomFilters({ ...customFilters, [e.target.name]: e.target.value });
  };

  return (
    <section className='pb-4'>
      <div className='bg-white border rounded-5'>
        <section className='w-100 p-4 justify-content-center'>
          <MDBRow className='justify-content-center'>
            <MDBCol className='col-md-12 mt-3 text-center'>
              <p className='fa-lg'>Price:</p>

              <MDBRange name='min' min='80' max='120' value={customFilters.min} label='Min' onChange={onChange} />

              <p id='min-val'>Current: {customFilters.min}$</p>

              <MDBRange name='max' min='80' max='120' value={customFilters.max} label='Max' onChange={onChange} />

              <p id='max-val'>Current: {customFilters.max}$</p>
            </MDBCol>
          </MDBRow>
          <MDBFilters
            filterData={setBasicData}
            data={exampleData}
            filters={customFilters}
            filterOptions={[
              {
                type: 'custom',
                key: 'min',
                custom: (data, key, filter) => {
                  return data.filter((item) =>
                    item.salePrice ? item.salePrice >= filter : item.price >= filter
                  );
                },
              },
              {
                type: 'custom',
                key: 'max',
                custom: (data, key, filter) => {
                  return data.filter((item) =>
                    item.salePrice ? item.salePrice <= filter : item.price <= filter
                  );
                },
              },
            ]}
          >
            {basicData.map((item, i) => (
              <MDBCol key={i} md='4' className='mt-3 basic-example-item'>
                <MDBCard className='card shadow-2'>
                  <img src={item.img} className='card-img-top' alt='...' />

                  <MDBCardBody>
                    <h5 className='card-title'>{item.name}</h5>
                    {item.sale === 'yes' ? (
                      <MDBCardText>
                        <span className='text-decoration-line-through'>{item.oldPrice}$</span>
                        <span className='fw-bold fa-lg'>{item.price}$</span>
                      </MDBCardText>
                    ) : (
                      <MDBCardText className='card-text'>{item.price}$</MDBCardText>
                    )}

                    <a href='#' className='btn btn-primary ripple-surface'>
                      Buy now
                    </a>
                  </MDBCardBody>
                </MDBCard>
              </MDBCol>
            ))}
          </MDBFilters>
        </section>
      </div>
    </section>
  );
}

Custom sort

import React, { useEffect, useState } from 'react';
import { MDBCol, MDBRow, MDBRadio, MDBBtn, MDBCardText, MDBCardBody, MDBCard, MDBSelect } from 'mdb-react-ui-kit';
import { MDBFilters } from 'mdb-react-filters';

const exampleData = [
  {
    name: 'Black Jeans Jacket',
    price: 100,
    color: 'black',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
  },
  {
    name: 'Gray Jumper',
    oldPrice: 100,
    price: 80,
    color: 'gray',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
  },

  {
    name: 'Blue Jeans Jacket',
    price: 90,
    color: 'blue',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
  },
  {
    name: 'Red Hoodie',
    oldPrice: 150,
    price: 120,
    color: 'red',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
  },
  {
    name: 'Black Jeans Jacket',
    price: 100,
    color: 'black',
    sale: 'no',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
  },
  {
    name: 'Gray Jumper',
    oldPrice: 100,
    price: 80,
    color: 'gray',
    sale: 'yes',
    img: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
  },
];

export default function App() {
  const [basicData, setBasicData] = useState(exampleData);
  const [sort, setSort] = useState({
    sortProperty: 'name',
    order: 'asc',
    customSort: (firstItem, secondItem) => {
      if (firstItem < secondItem) return -1;
      if (firstItem > secondItem) return 1;
      return 0;
    },
  });

  return (
    <section className='pb-4'>
      <div className='bg-white border rounded-5'>
        <section className='w-100 p-4 justify-content-center'>
          <MDBRow className='justify-content-center'>
            <MDBCol md='4' className='text-center'>
              <MDBBtn
                onClick={() =>
                  setSort({
                    ...sort,
                    order: 'asc',
                    customSort: (firstItem, secondItem) => {
                      if (firstItem < secondItem) return -1;
                      if (firstItem > secondItem) return 1;
                      return 0;
                    },
                  })
                }
              >
                Sort by product name ascending
              </MDBBtn>
            </MDBCol>

            <MDBCol md='4' className='text-center'>
              <MDBBtn
                onClick={() =>
                  setSort({
                    ...sort,
                    order: 'desc',
                    customSort: (firstItem, secondItem) => {
                      if (firstItem > secondItem) return -1;
                      if (firstItem < secondItem) return 1;
                      return 0;
                    },
                  })
                }
              >
                Sort by product name descending
              </MDBBtn>
            </MDBCol>
          </MDBRow>
          <MDBFilters filteredData={basicData} filterData={setBasicData} sortOptions={sort} data={exampleData}>
            {basicData.map((item, i) => (
              <MDBCol key={i} md='4' className='mt-3 basic-example-item'>
                <MDBCard className='card shadow-2'>
                  <img src={item.img} className='card-img-top' alt='...' />

                  <MDBCardBody>
                    <h5 className='card-title'>{item.name}</h5>
                    {item.sale === 'yes' ? (
                      <MDBCardText>
                        <span className='text-decoration-line-through'>{item.oldPrice}$</span>{' '}
                        <span className='fw-bold fa-lg'>{item.price}$</span>
                      </MDBCardText>
                    ) : (
                      <MDBCardText className='card-text'>{item.price}$</MDBCardText>
                    )}

                    <a href='#' className='btn btn-primary ripple-surface'>
                      Buy now
                    </a>
                  </MDBCardBody>
                </MDBCard>
              </MDBCol>
            ))}
          </MDBFilters>
        </section>
      </div>
    </section>
  );
}

Full screen example

import { MDBFilters } from 'mdb-react-filters';
import {
  MDBContainer,
  MDBNavbar,
  MDBNavbarToggler,
  MDBIcon,
  MDBCollapse,
  MDBDropdownMenu,
  MDBNavbarLink,
  MDBNavbarItem,
  MDBBtn,
  MDBDropdownItem,
  MDBDropdownToggle,
  MDBDropdown,
  MDBNavbarNav,
  MDBBadge,
  MDBRow,
  MDBCol,
  MDBSelect,
  MDBAnimation,
  MDBCheckbox,
  MDBRating,
  MDBRatingElement,
  MDBRadio,
  MDBRipple,
  MDBFooter,
} from 'mdb-react-ui-kit';
import React, { useState } from 'react';

const advancedData = [
  {
    id: 1,
    category: 'shirts',
    name: 'Fantasy T-shirt',
    rating: 4,
    image: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
    description:
      'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
    available: true,
    size: ['34', '36', '40'],
    condition: 'new',
    color: 'blue',
    price: 12.99,
    keywords: ['t-shirt', 'sweatshitrt'],
    discount: 0,
    gender: 'male',
  },
  {
    id: 2,
    category: 'shirts',
    name: 'Fantasy T-shirt',
    rating: 5,
    image: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
    description:
      'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
    available: true,
    size: ['34', '36', '40', '44'],
    condition: 'new',
    color: 'red',
    price: 12.99,
    discount: 0,
    gender: 'male',
  },
  {
    id: 3,
    category: 'shirts',
    name: 'Fantasy T-shirt',
    rating: 3,
    image: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
    description:
      'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
    available: true,
    size: ['34', '36'],
    condition: 'new',
    color: 'grey',
    price: 40.99,
    discount: 10,
    gender: 'male',
  },
  {
    id: 4,
    category: 'jackets',
    name: 'Denim Jacket',
    rating: 5,
    image: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
    description:
      'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
    available: true,
    size: ['34', '36', '40'],
    condition: 'new',
    color: 'grey',
    price: 40.99,
    discount: 0,
    gender: 'unisex',
  },
  {
    id: 5,
    category: 'jeans',
    name: 'Ripped jeans',
    rating: 5,
    image: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/11.webp',
    description:
      'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
    available: true,
    size: ['34', '36', '38', '40'],
    condition: 'renewed',
    color: 'blue',
    price: 20.99,
    discount: 5,
    gender: 'female',
  },
  {
    id: 6,
    category: 'jeans',
    name: 'Boyfriend jeans',
    rating: 4,
    image: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/10.webp',
    description:
      'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
    available: false,
    size: ['34', '36', '38', '40'],
    condition: 'used',
    color: 'blue',
    price: 20.99,
    discount: 5,
    gender: 'female',
  },
  {
    id: 7,
    category: 'shirts',
    name: 'Ripped sweatshirt',
    rating: 4,
    image: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/7.webp',
    description:
      'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
    available: true,
    size: ['34', '36', '38', '40'],
    condition: 'collectible',
    color: 'white',
    price: 29.99,
    discount: 5,
    gender: 'female',
  },
  {
    id: 8,
    category: 'shirts',
    name: 'Longsleeve',
    rating: 4,
    image: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/8.webp',
    description:
      'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
    available: true,
    size: ['40'],
    condition: 'collectible',
    color: 'black',
    price: 120.99,
    discount: 0,
    gender: 'male',
  },
  {
    id: 8,
    category: 'shirts',
    name: 'Stripped sweatshirt',
    rating: 4,
    image: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/6.webp',
    description:
      'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
    available: true,
    size: ['40', '38', '36'],
    condition: 'new',
    color: 'white',
    price: 32.99,
    discount: 10,
    gender: 'female',
  },
  {
    id: 9,
    category: 'trousers',
    name: 'Red chinos',
    rating: 5,
    image: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/5.webp',
    description:
      'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
    available: true,
    size: ['40', '38', '36'],
    condition: 'new',
    color: 'red',
    price: 62.99,
    discount: 10,
    gender: 'female',
  },
  {
    id: 10,
    category: 'coats',
    name: 'Camel coat',
    rating: 5,
    image: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/4.webp',
    description:
      'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
    available: true,
    size: ['40', '38', '36'],
    condition: 'used',
    color: 'brown',
    price: 62.99,
    discount: 10,
    gender: 'female',
  },
  {
    id: 11,
    category: 'jeans',
    name: 'Blue jeans',
    rating: 5,
    image: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/3.webp',
    description:
      'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
    available: true,
    size: ['40', '38', '36'],
    condition: 'new',
    color: 'blue',
    price: 42.99,
    discount: 0,
    gender: 'female',
  },
  {
    id: 12,
    category: 'shirts',
    name: 'Orange T-shirt',
    rating: 3,
    image: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/3.webp',
    description:
      'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
    available: true,
    size: ['40', '38', '36'],
    condition: 'new',
    color: 'orange',
    price: 12.99,
    discount: 0,
    gender: 'female',
  },
  {
    id: 13,
    category: 'skirts',
    name: 'Ballerina skirt',
    rating: 4,
    image: 'https://mdbootstrap.com/img/Photos/Horizontal/E-commerce/Vertical/2.webp',
    description:
      'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
    available: true,
    size: ['38', '36'],
    condition: 'collectible',
    color: 'white',
    price: 12.99,
    discount: 0,
    gender: 'female',
  },
];

export default function App() {
  const [showNavText, setShowNavText] = useState(false);
  const [filterData, setFilterData] = useState(advancedData);
  const [sort, setSort] = useState({ sortProperty: '', order: 'asc' });
  const [filters, setFilters] = useState({ condition: [], rating: 0, price: { min: 0, max: Infinity }, size: [], color: '' });

  const handleGetValue = (e) => {
    const value = e;

    if (value === 1) {
      setSort({ sortProperty: 'rating', order: 'desc' });
    }

    if (value === 2) {
      setSort({ sortProperty: 'price', order: 'asc' });
    }

    if (value === 3) {
      setSort({ sortProperty: 'price', order: 'desc' });
    }
  };

  const onChangeCheckbox = (e: { target: { name, value } }) => {
    const containsValue = (filters[e.target.name]).includes(e.target.value);

    if (containsValue) {
      setFilters({
        ...filters,
        [e.target.name]: (filters[e.target.name]).filter((element) => element !== e.target.value),
      });
    } else {
      const newArray = [...(filters[e.target.name]), e.target.value];

      setFilters({ ...filters, [e.target.name]: newArray });
    }
  };

  const onChangeRadio = (e) => {
    const values = e.target.value.split('-');

    setFilters({ ...filters, [e.target.name]: { min: parseInt(values[0]), max: parseInt(values[1]) } });
  };

  const onChangeColor = (e) => {
    setFilters({ ...filters, [e.target.name]: e.target.value });
  };

  return (
    <>
      <header>
        <MDBNavbar sticky expand='lg' light className='bg-light'>
          <MDBContainer fluid className='justify-content-between'>
            <MDBNavbarToggler
              type='button'
              data-target='#navbarText'
              aria-controls='navbarText'
              aria-expanded='false'
              aria-label='Toggle navigation'
              onClick={() => setShowNavText(!showNavText)}
            >
              <MDBIcon icon='bars' fas />
            </MDBNavbarToggler>
            <a className='navbar-brand' href='https://mdbecommerce.com/'>
              <MDBIcon fab icon='mdb' className='fa-2x' />
            </a>

            <MDBCollapse navbar show={showNavText}>
              <MDBNavbarNav className='ml-auto'>
                <MDBNavbarItem className='nav-item my-auto'>
                  <a className='nav-link active' aria-current='page' href='#'>
                    <MDBBadge className='rounded-pill' color='danger'>
                      1
                    </MDBBadge>
                    <MDBIcon fas icon='shopping-cart' />
                  </a>
                </MDBNavbarItem>

                <MDBDropdown className='nav-item my-auto'>
                  <MDBDropdownToggle className='nav-link' tag='a'>
                    <i className='united kingdom flag m-0'></i>
                  </MDBDropdownToggle>
                  <MDBDropdownMenu>
                    <MDBDropdownItem link>Action</MDBDropdownItem>
                    <MDBDropdownItem link>Another action</MDBDropdownItem>
                    <MDBDropdownItem link>Something else here</MDBDropdownItem>
                  </MDBDropdownMenu>
                </MDBDropdown>
                <MDBNavbarItem className='my-auto'>
                  <MDBNavbarLink>Shop</MDBNavbarLink>
                </MDBNavbarItem>
                <MDBNavbarItem className='my-auto'>
                  <MDBNavbarLink>Contact</MDBNavbarLink>
                </MDBNavbarItem>
                <MDBNavbarItem className='my-auto'>
                  <MDBNavbarLink>Sign in</MDBNavbarLink>
                </MDBNavbarItem>
                <MDBNavbarItem>
                  <MDBNavbarLink>
                    <MDBBtn outline color='dark' rounded>
                      Sign up
                    </MDBBtn>
                  </MDBNavbarLink>
                </MDBNavbarItem>
              </MDBNavbarNav>
            </MDBCollapse>
          </MDBContainer>
        </MDBNavbar>

        <div
          className='p-5 text-center bg-image'
          style={{
            backgroundImage: "url('https://mdbootstrap.com/img/Photos/Others/clothes(5)-crop.webp')",
            height: '400px',
          }}
        >
          <div className='mask' style={{ backgroundColor: 'rgba(0, 0, 0, 0.7)' }}>
            <div className='d-flex justify-content-center align-items-center h-100'>
              <div className='text-white'>
                <h1 className='mb-3'>Shop</h1>
              </div>
            </div>
          </div>
        </div>
      </header>

      <main>
        <MDBContainer className='mt-5'>
          <MDBRow>
            <MDBCol md='4'>
              <section>
                <h5>Filters</h5>

                <section className='mb-4'>
                  <h6 className='font-weight-bold mb-3'>Condition</h6>

                  <MDBCheckbox
                    name='condition'
                    onChange={onChangeCheckbox}
                    value='new'
                    checked={filters.condition.includes('new')}
                    label='NEW'
                    labelClass='text-muted small'
                    wrapperClass='mb-3'
                  />

                  <MDBCheckbox
                    name='condition'
                    onChange={onChangeCheckbox}
                    value='used'
                    checked={filters.condition.includes('used')}
                    label='USED'
                    labelClass='text-muted small'
                    wrapperClass='mb-3'
                  />

                  <MDBCheckbox
                    name='condition'
                    onChange={onChangeCheckbox}
                    value='collectible'
                    checked={filters.condition.includes('collectible')}
                    label='COLLECTIBLE'
                    labelClass='text-muted small'
                    wrapperClass='mb-3'
                  />

                  <MDBCheckbox
                    name='condition'
                    onChange={onChangeCheckbox}
                    value='renewed'
                    checked={filters.condition.includes('renewed')}
                    label='RENEWED'
                    labelClass='text-muted small'
                    wrapperClass='mb-3'
                  />
                </section>

                <section className='mb-4'>
                  <h6 className='font-weight-bold mb-3'>Avg. Customer Review</h6>

                  <MDBRating
                    active={filters.rating}
                    setActive={(value) => setFilters({ ...filters, rating: value })}
                  >
                    <MDBRatingElement title='1' itemId={1} icon='star' />
                    <MDBRatingElement title='2' itemId={2} icon='star' />
                    <MDBRatingElement title='3' itemId={3} icon='star' />
                    <MDBRatingElement title='4' itemId={4} icon='star' />
                    <MDBRatingElement title='5' itemId={5} icon='star' />
                  </MDBRating>
                </section>

                <section className='mb-4'>
                  <h6 className='font-weight-bold mb-3'>Price</h6>

                  <MDBRadio
                    name='price'
                    onChange={onChangeRadio}
                    value='0-25'
                    checked={JSON.stringify(filters.price) === JSON.stringify({ min: 0, max: 25 })}
                    label='UNDER $25'
                    labelClass='text-muted small'
                    wrapperClass='mb-3'
                  />

                  <MDBRadio
                    name='price'
                    onChange={onChangeRadio}
                    value='25-50'
                    checked={JSON.stringify(filters.price) === JSON.stringify({ min: 25, max: 50 })}
                    label='$25 TO $50'
                    labelClass='text-muted small'
                    wrapperClass='mb-3'
                  />

                  <MDBRadio
                    name='price'
                    value='50-100'
                    onChange={onChangeRadio}
                    checked={JSON.stringify(filters.price) === JSON.stringify({ min: 50, max: 100 })}
                    label='$50 TO $100'
                    labelClass='text-muted small'
                    wrapperClass='mb-3'
                  />

                  <MDBRadio
                    name='price'
                    value='100-200'
                    onChange={onChangeRadio}
                    checked={JSON.stringify(filters.price) === JSON.stringify({ min: 100, max: 200 })}
                    label='$100 TO $200'
                    labelClass='text-muted small'
                    wrapperClass='mb-3'
                  />

                  <MDBRadio
                    name='price'
                    value='200-'
                    onChange={onChangeRadio}
                    checked={JSON.stringify(filters.price) === JSON.stringify({ min: 200, max: Infinity })}
                    label='$200 & ABOVE'
                    labelClass='text-muted small'
                    wrapperClass='mb-3'
                  />
                </section>

                <section className='mb-4'>
                  <h6 className='font-weight-bold mb-3'>Price</h6>

                  <MDBCheckbox
                    name='size'
                    value='34'
                    onChange={onChangeCheckbox}
                    checked={filters.size.includes('34')}
                    label='34'
                    labelClass='text-muted small'
                    wrapperClass='mb-3'
                  />

                  <MDBCheckbox
                    name='size'
                    onChange={onChangeCheckbox}
                    value='36'
                    checked={filters.size.includes('36')}
                    label='36'
                    labelClass='text-muted small'
                    wrapperClass='mb-3'
                  />

                  <MDBCheckbox
                    name='size'
                    value='38'
                    onChange={onChangeCheckbox}
                    checked={filters.size.includes('38')}
                    label='38'
                    labelClass='text-muted small'
                    wrapperClass='mb-3'
                  />

                  <MDBCheckbox
                    name='size'
                    value='40'
                    onChange={onChangeCheckbox}
                    checked={filters.size.includes('40')}
                    label='40'
                    labelClass='text-muted small'
                    wrapperClass='mb-3'
                  />
                </section>

                <section className='mb-4'>
                  <h6 className='font-weight-bold mb-3'>Color</h6>
                  <div className='form-check form-check-inline m-0 p-0 pr-3'>
                    <input
                      onChange={onChangeColor}
                      checked={filters.color === 'white'}
                      className='btn-check'
                      type='radio'
                      name='color'
                      id='colorRadio4'
                      value='white'
                    />
                    <MDBRipple
                      rippleTag='label'
                      className='btn btn-light btn-rounded p-3 '
                      htmlFor='colorRadio4'
                    ></MDBRipple>
                  </div>

                  <div className='form-check form-check-inline m-0 p-0 pr-3'>
                    <input
                      onChange={onChangeColor}
                      checked={filters.color === 'grey'}
                      className='btn-check'
                      type='radio'
                      name='color'
                      id='colorRadio6'
                      value='grey'
                    />
                    <MDBRipple
                      style={{ backgroundColor: '#bdbdbd' }}
                      rippleTag='label'
                      className='btn btn-rounded p-3 '
                      htmlFor='colorRadio6'
                    ></MDBRipple>
                  </div>

                  <div className='form-check form-check-inline m-0 p-0 pr-3'>
                    <input
                      onChange={onChangeColor}
                      checked={filters.color === 'black'}
                      className='btn-check'
                      type='radio'
                      name='color'
                      id='colorRadio3'
                      value='black'
                    />
                    <MDBRipple
                      rippleTag='label'
                      className='btn bg-dark text-white btn-rounded p-3 '
                      htmlFor='colorRadio3'
                    ></MDBRipple>
                  </div>

                  <div className='form-check form-check-inline m-0 p-0 pr-3'>
                    <input
                      onChange={onChangeColor}
                      checked={filters.color === 'blue'}
                      className='btn-check'
                      type='radio'
                      name='color'
                      id='colorRadio2'
                      value='blue'
                    />
                    <MDBRipple
                      rippleTag='label'
                      className='btn bg-primary btn-rounded p-3 '
                      htmlFor='colorRadio2'
                    ></MDBRipple>
                  </div>

                  <div style={{ paddingRight: '1rem' }} className='form-check form-check-inline m-0 p-0'>
                    <input
                      onChange={onChangeColor}
                      checked={filters.color === 'red'}
                      className='btn-check'
                      type='radio'
                      name='color'
                      id='colorRadio1'
                      value='red'
                    />

                    <MDBRipple
                      rippleTag='label'
                      className='btn bg-danger btn-rounded p-3 '
                      htmlFor='colorRadio1'
                    ></MDBRipple>
                  </div>

                  <div className='form-check form-check-inline m-0 p-0 pr-3'>
                    <input
                      onChange={onChangeColor}
                      checked={filters.color === 'orange'}
                      className='btn-check'
                      type='radio'
                      name='color'
                      id='colorRadio5'
                      value='orange'
                    />
                    <MDBRipple
                      rippleTag='label'
                      className='btn btn-rounded bg-warning p-3 '
                      htmlFor='colorRadio5'
                    ></MDBRipple>
                  </div>
                </section>
              </section>
            </MDBCol>
            <MDBCol md='8'>
              <MDBRow className='justify-content-center'>
                <MDBCol md='6' className='my-auto py-3'>
                  <MDBSelect
                    getSelectedValue={handleGetValue}
                    label='Sort'
                    data={[
                      { text: 'Best rating', value: 1, selected: true },
                      { text: 'Lowest price first', value: 2 },
                      { text: 'Highest price first', value: 3 },
                    ]}
                  />
                </MDBCol>
              </MDBRow>
              <MDBFilters
                filters={filters}
                filterOptions={[
                  { type: 'checkbox', key: 'condition' },
                  {
                    type: 'custom',
                    key: 'rating',
                    custom: (data, key, filter) => {
                      return filter ? data.filter((item) => item.rating === filter) : data;
                    },
                  },
                  {
                    type: 'custom',
                    key: 'price',
                    custom: (data, key, filter) => {
                      return filter
                        ? data.filter((item) => item.price >= filter.min && item.price <= filter.max)
                        : data;
                    },
                  },
                  {
                    type: 'custom',
                    key: 'size',
                    custom: (data, key, filter) => {
                      return filter.length
                        ? data.filter((item) => item.size.some((size) => filter.includes(size)))
                        : data;
                    },
                  },
                  {
                    type: 'radio',
                    key: 'color',
                  },
                ]}
                filterData={setFilterData}
                data={advancedData}
                sortOptions={sort}
                className='mb-4'
              >
                {filterData.map((item, i) => (
                  <MDBCol key={i} md='4' className='col-md-4 my-4 justify-content-center text-center'>
                    <MDBAnimation key={Math.random()} animation='fade-in' start='onLoad' tag='div'>
                      <div className='bg-image hover-overlay hover-zoom hover-shadow ripple rounded'>
                        <img src={item.image} className='img-fluid w-100' style={{ height: '325px' }} />
                        <a href='#!'>
                          <div className='mask rounded' style={{ backgroundColor: 'rgba(66, 66, 66, 0.2)' }}></div>
                        </a>
                      </div>
                      <div className='pt-4'>
                        <h5>{item.name}</h5>
                        <strong>${item.price}</strong>
                      </div>
                    </MDBAnimation>
                  </MDBCol>
                ))}
              </MDBFilters>
            </MDBCol>
          </MDBRow>
        </MDBContainer>
      </main>

      <MDBFooter className='bg-dark text-white text-lg-left'>
        <div className='bg-primary text-center p-3'>
          <MDBRow>
            <MDBCol md='6'>
              <span className='font-weight-bold'>Get connected with us on social networks!</span>
            </MDBCol>
            <MDBCol md='6'>
              <MDBIcon fab icon='instagram' />
              <MDBIcon fab icon='linkedin-in' style={{ marginLeft: '1.5rem' }} />
              <MDBIcon fab icon='twitter' style={{ marginLeft: '1.5rem' }} />
              <MDBIcon fab icon='facebook-f' style={{ marginLeft: '1.5rem' }} />
            </MDBCol>
          </MDBRow>
        </div>

        <div className='container p-5'>
          <div className='row p-2'>
            <div className='col-md-3 mx-auto py-4'>
              <h5 className='text-uppercase'>About me</h5>
              <hr className='mb-4 mt-0' />

              <p>
                Here you can use rows and columns to organize your footer content. Lorem ipsum dolor sit amet,
                consectetur adipisicing elit.
              </p>
            </div>

            <div className='col-md-3 mx-auto py-4'>
              <h5 className='text-uppercase'>Products</h5>
              <hr className='mb-4 mt-0' />

              <ul className='list-unstyled mb-0'>
                <li className='mb-2'>
                  <a href='#!' className='text-white'>
                    MDBootstrap
                  </a>
                </li>
                <li className='mb-2'>
                  <a href='#!' className='text-white'>
                    MDWordPress
                  </a>
                </li>
                <li className='mb-2'>
                  <a href='#!' className='text-white'>
                    BrandFlow
                  </a>
                </li>
                <li>
                  <a href='#!' className='text-white'>
                    Bootstrap Angular
                  </a>
                </li>
              </ul>
            </div>

            <div className='col-md-3 mx-auto py-4'>
              <h5 className='text-uppercase'>Useful links</h5>
              <hr className='mb-4 mt-0' />

              <ul className='list-unstyled'>
                <li className='mb-2'>
                  <a href='#!' className='text-white'>
                    Your Account
                  </a>
                </li>
                <li className='mb-2'>
                  <a href='#!' className='text-white'>
                    Become an Affiliate
                  </a>
                </li>
                <li className='mb-2'>
                  <a href='#!' className='text-white'>
                    Shipping Rates
                  </a>
                </li>
                <li>
                  <a href='#!' className='text-white'>
                    Help
                  </a>
                </li>
              </ul>
            </div>

            <div className='col-md-3 mx-auto py-4'>
              <h5 className='text-uppercase'>Contacts</h5>
              <hr className='mb-4 mt-0' />

              <ul className='list-unstyled'>
                <li className='mb-2'>
                  <a href='#!' className='text-white'>
                    <i className='far fa-map mr-1'></i> New York, Avenue Street 10
                  </a>
                </li>
                <li className='mb-2'>
                  <a href='#!' className='text-white'>
                    <i className='fas fa-phone-alt mr-1'></i> 042 876 836 908
                  </a>
                </li>
                <li className='mb-2'>
                  <a href='#!' className='text-white'>
                    <i className='far fa-envelope mr-1'></i> company@example.com
                  </a>
                </li>
                <li>
                  <a href='#!' className='text-white'>
                    <i className='far fa-clock mr-1'></i> Monday - Friday: 10-17
                  </a>
                </li>
              </ul>
            </div>
          </div>
        </div>
        <div className='text-center p-3' style={{ backgroundColor: 'rgba(0, 0, 0, 0.2)' }}>
          © 2020 Copyright:
          <a className='text-white' href='https://mdbootstrap.com/'>
            MDBootstrap.com
          </a>
        </div>
      </MDBFooter>
    </>
  );
}

Filters - API


Import

import { MDBFilters } from 'mdb-react-filters';

Properties

Filters

Name Type Default Description Example
data Array<any> - Array with the original data. <MDBFilters data={exampleData} />
filterData React.SetStateAction<any> Intented to set the state of the filtered data. <MDBFilters filterData={setData} />
filterOptions Array<FilterOptionsObject> Defines the filter options. <MDBFilters filterOptions={options} />
filters any Defines the active filters <MDBFilters filters={exampleFilters} />
sortOptions SortOptionsObject - Defines the sort options. <MDBFilters sortOptions={options} />

Advanced types

FilterOptionsObject

type FilterOptionsObject = {
  key: string;
  type: 'custom' | 'radio' | 'checkbox';
  custom?: (data: Array<any>, key: string, filter: number | string | boolean | any) => Array<any>;
};

SortOptionsObject

type SortOptionsObject = {
  sortProperty: string;
  order: string;
  customSort?: (firstItem: string, secondItem: string) => 1 | 0 | -1;
};

Filters

Angular Bootstrap 5 Filters plugin

Filters are the best way to select data that meets your requirements - they affect your search results by filtrating and sorting the dataset you pass to our component.

View full screen demo

Basic example

Filter: Color
Filter: Sale
...
Black Jeans Jacket

100$

Buy now
...
Black Jeans Jacket

100$

Buy now
...
Gray Jumper

80$

Buy now
...
Gray Jumper

80$

Buy now
...
Red Hoodie

120$

Buy now
...
Blue Jeans Jacket

90$

Buy now
<div class="container">
  <form [formGroup]="filtersGroup">
    <div class="col-md-6">
      <span class="fa-lg">Filter: Color</span>

      <div class="form-check mt-3">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="color"
          id="arrayRadio1"
          value="black"
          formControlName="color"
        />
        <label class="form-check-label" for="arrayRadio1">Black</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="color"
          id="arrayRadio2"
          value="red"
          formControlName="color"
        />
        <label class="form-check-label" for="arrayRadio2">Red</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="color"
          id="arrayRadio3"
          value="blue"
          formControlName="color"
        />
        <label class="form-check-label" for="arrayRadio3">Blue</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="color"
          id="arrayRadio4"
          value="gray"
          formControlName="color"
        />
        <label class="form-check-label" for="arrayRadio4">Gray</label>
      </div>
    </div>

    <div class="col-md-6">
      <span class="fa-lg mb-5">Filter: Sale</span>

      <div class="form-check mt-3">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="sale"
          id="arrayRadio5"
          value="yes"
          formControlName="sale"
        />
        <label class="form-check-label" for="arrayRadio5">Yes</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="sale"
          id="arrayRadio6"
          value="no"
          formControlName="sale"
        />
        <label class="form-check-label" for="arrayRadio6">No</label>
      </div>

      <button (click)="clearFilters()" type="button" class="btn btn-primary mt-3">
        Clear all filters
      </button>
    </div>
  </form>

  <div class="row text-center">
    <div *ngFor="let item of filteredItems$ | async" class="col-md-4 mt-3" style="max-width: 350px;">
      <div class="card shadow-2">
        <img [attr.src]="item.img" class="card-img-top" alt="..." />
        <div class="card-body">
          <h5 class="card-title">{{ item.product }}</h5>
          <p class="card-text">{{ item.price }} $</p>
          <a href="#" class="btn btn-primary">Buy now</a>
        </div>
      </div>
    </div>
  </div>
</div>
import { Component } from '@angular/core';
import { FormControl, FormGroup } from '@angular/forms';
import { Observable } from 'rxjs';
import { map, startWith } from 'rxjs/operators';

export interface Item {
  id: number;
  color: string;
  price: number;
  sale: string;
  product: string;
  img: string;
  size: number[];
}

export interface BasicFilters {
  color: string | null;
  sale: string | null;
}

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss'],
})
export class AppComponent {
  items: Item[] = [
    {
      id: 1,
      color: 'black',
      price: 100,
      sale: 'no',
      product: 'Black Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
      size: [36, 40, 42],
    },
    {
      id: 2,
      color: 'black',
      price: 100,
      sale: 'no',
      product: 'Black Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
      size: [36, 38, 40, 42],
    },
    {
      id: 3,
      color: 'gray',
      price: 80,
      sale: 'yes',
      product: 'Gray Jumper',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
      size: [36, 38, 40],
    },
    {
      id: 4,
      color: 'gray',
      price: 80,
      sale: 'yes',
      product: 'Gray Jumper',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
      size: [40, 42],
    },
    {
      id: 5,
      color: 'red',
      price: 120,
      sale: 'yes',
      product: 'Red Hoodie',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
      size: [36, 40, 42],
    },
    {
      id: 6,
      color: 'blue',
      price: 90,
      sale: 'no',
      product: 'Blue Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
      size: [36, 38],
    },
  ];

  filteredItems$: Observable<Item[]>;
  filtersGroup: FormGroup;

  basicFilters: BasicFilters = {
    color: null,
    sale: null,
  };

  constructor() {
    this.filtersGroup = new FormGroup({
      color: new FormControl(),
      sale: new FormControl(),
    });

    this.filteredItems$ = this.filtersGroup.valueChanges.pipe(
      startWith(this.basicFilters),
      map((filters: BasicFilters) => {
        const { color, sale } = filters;
        let items = this.items;

        if (color) {
          items = items.filter((item) => item.color === color);
        }

        if (sale) {
          items = items.filter((item) => item.sale === sale);
        }

        return items;
      })
    );
  }

  clearFilters() {
    this.filtersGroup.reset();
  }
}

Checkbox example

Note: If there is more than one option, the result of filtering will show items that match both of them.

Filter: Color
Filter: Sale
Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
Blue Jeans Jacket
Blue Jeans Jacket

90$

Buy now
Red Hoodie
Red Hoodie

150$ 120$

Buy now
Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
<div class="container">
  <form [formGroup]="filtersGroup">
    <div class="col-md-6">
      <span class="fa-lg">Filter: Color</span>

      <div class="form-check mt-3">
        <input
          mdbInput
          class="form-check-input"
          type="checkbox"
          name="color"
          id="arrayCheckbox1"
          value="black"
          formControlName="black"
        />
        <label class="form-check-label" for="arrayCheckbox1">Black</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="checkbox"
          name="color"
          id="arrayCheckbox2"
          value="red"
          formControlName="red"
        />
        <label class="form-check-label" for="arrayCheckbox2">Red</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="checkbox"
          name="color"
          id="arrayCheckbox3"
          value="blue"
          formControlName="blue"
        />
        <label class="form-check-label" for="arrayCheckbox3">Blue</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="checkbox"
          name="color"
          id="arrayCheckbox4"
          value="gray"
          formControlName="gray"
        />
        <label class="form-check-label" for="arrayCheckbox4">Gray</label>
      </div>
    </div>

    <div class="col-md-6">
      <span class="fa-lg mb-5">Filter: Sale</span>

      <div class="form-check mt-3">
        <input
          mdbInput
          class="form-check-input"
          type="checkbox"
          name="sale"
          id="arrayCheckbox5"
          value="yes"
          formControlName="saleYes"
        />
        <label class="form-check-label" for="arrayCheckbox5">Yes</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="checkbox"
          name="sale"
          id="arrayCheckbox6"
          value="no"
          formControlName="saleNo"
        />
        <label class="form-check-label" for="arrayCheckbox6">No</label>
      </div>

      <button (click)="clearFilters()" type="button" class="btn btn-primary mt-3">
        Clear all filters
      </button>
    </div>
  </form>

  <div class="row text-center">
    <div *ngFor="let item of filteredItems$ | async" class="col-md-4 mt-3"  style="max-width: 350px;">
      <div class="card shadow-2">
        <img [attr.src]="item.img" class="card-img-top" alt="..." />
        <div class="card-body">
          <h5 class="card-title">{{ item.product }}</h5>
          <p class="card-text">{{ item.price }} $</p>
          <a href="#" class="btn btn-primary">Buy now</a>
        </div>
      </div>
    </div>
  </div>
</div>
import { Component } from '@angular/core';
import { FormControl, FormGroup } from '@angular/forms';
import { Observable } from 'rxjs';
import { map, startWith } from 'rxjs/operators';

export interface Item {
  id: number;
  color: string;
  price: number;
  sale: string;
  product: string;
  img: string;
  size: number[];
}
export interface Filters {
  [key: string]: string | null;
  black: string | null;
  red: string | null;
  blue: string | null;
  gray: string | null;
  saleYes: string | null;
  saleNo: string | null;
}


@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss'],
})
export class AppComponent {
  items: Item[] = [
    {
      id: 1,
      color: 'black',
      price: 100,
      sale: 'no',
      product: 'Black Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
      size: [36, 40, 42],
    },
    {
      id: 2,
      color: 'black',
      price: 100,
      sale: 'no',
      product: 'Black Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
      size: [36, 38, 40, 42],
    },
    {
      id: 3,
      color: 'gray',
      price: 80,
      sale: 'yes',
      product: 'Gray Jumper',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
      size: [36, 38, 40],
    },
    {
      id: 4,
      color: 'gray',
      price: 80,
      sale: 'yes',
      product: 'Gray Jumper',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
      size: [40, 42],
    },
    {
      id: 5,
      color: 'red',
      price: 120,
      sale: 'yes',
      product: 'Red Hoodie',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
      size: [36, 40, 42],
    },
    {
      id: 6,
      color: 'blue',
      price: 90,
      sale: 'no',
      product: 'Blue Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
      size: [36, 38],
    },
  ];

  filteredItems$: Observable<Item[]>;
  filtersGroup: FormGroup;

  defaultFilters: Filters = {
    black: null,
    red: null,
    blue: null,
    gray: null,
    saleYes: null,
    saleNo: null,
  };

  constructor() {
    this.filtersGroup = new FormGroup({
      black: new FormControl(),
      red: new FormControl(),
      blue: new FormControl(),
      gray: new FormControl(),
      saleYes: new FormControl(),
      saleNo: new FormControl(),
    });

    this.filteredItems$ = this.filtersGroup.valueChanges.pipe(
      startWith(this.defaultFilters),
      map((controls: Filters) => {
        let items = this.items;
        const colors = Object.keys(controls).filter(
          (control) => controls[control] && !control.startsWith('sale')
        );

        const sales = Object.keys(controls)
          .filter((control) => controls[control] && control.startsWith('sale'))
          .map((string) => string.toLowerCase().replace('sale', ''));

        if (colors.length > 0) {
          items = items.filter((item) => colors.some((color) => item.color === color));
        }

        if (sales.length > 0) {
          items = items.filter((item) => sales.some((sale) => item.sale === sale));
        }
        return items;
      })
    );

  }

  clearFilters() {
    this.filtersGroup.reset();
  }
}

Size example

Note: If there is more than one option, the result of filtering will show items that match both of them.

Filter: Size
Filter: Sale
Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
Blue Jeans Jacket
Blue Jeans Jacket

90$

Buy now
Red Hoodie
Red Hoodie

150$ 120$

Buy now
Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
<div class="container">
  <form [formGroup]="filtersGroup">
    <div class="col-md-6">
      <span class="fa-lg">Filter: Size</span>
      <div class="form-check mt-3">
        <input
          mdbInput
          class="form-check-input"
          type="checkbox"
          name="size"
          id="arrayCheckboxSize1"
          value="36"
          formControlName="36"
        />
        <label class="form-check-label" for="arrayCheckboxSize1">36</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="checkbox"
          name="size"
          id="arrayCheckboxSize2"
          value="38"
          formControlName="38"
        />
        <label class="form-check-label" for="arrayCheckboxSize2">38</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="checkbox"
          name="size"
          id="arrayCheckboxSize3"
          value="40"
          formControlName="40"
        />
        <label class="form-check-label" for="arrayCheckboxSize3">40</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="checkbox"
          name="size"
          id="arrayCheckboxSize4"
          value="42"
          formControlName="42"
        />
        <label class="form-check-label" for="arrayCheckboxSize4">42</label>
      </div>
    </div>

    <div class="col-md-6">
      <span class="fa-lg mb-5">Filter: Sale</span>

      <div class="form-check mt-3">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="sale"
          id="arrayCheckboxSize5"
          value="yes"
          formControlName="sale"
        />
        <label class="form-check-label" for="arrayCheckboxSize5">Yes</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="sale"
          id="arrayCheckboxSize6"
          value="no"
          formControlName="sale"
        />
        <label class="form-check-label" for="arrayCheckboxSize6">No</label>
      </div>

      <button (click)="clearFilters()" type="button" class="btn btn-primary mt-3">
        Clear all filters
      </button>
    </div>
  </form>

  <div class="row text-center">
    <div *ngFor="let item of filteredItems$ | async" class="col-md-4 mt-3"  style="max-width: 350px;">
      <div class="card shadow-2">
        <img [attr.src]="item.img" class="card-img-top" alt="..." />
        <div class="card-body">
          <h5 class="card-title">{{ item.product }}</h5>
          <p class="card-text">{{ item.price }} $</p>
          <a href="#" class="btn btn-primary">Buy now</a>
        </div>
      </div>
    </div>
  </div>
</div>
import { Component } from '@angular/core';
import { FormControl, FormGroup } from '@angular/forms';
import { Observable } from 'rxjs';
import { map, startWith } from 'rxjs/operators';

export interface Item {
  id: number;
  color: string;
  price: number;
  sale: string;
  product: string;
  img: string;
  size: number[];
}
export interface Filters {
  [key: string]: string | number | null;
  36: number | null;
  38: number | null;
  40: number | null;
  42: number | null;
  sale: string | null;
}

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss'],
})
export class AppComponent {
  items: Item[] = [
    {
      id: 1,
      color: 'black',
      price: 100,
      sale: 'no',
      product: 'Black Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
      size: [36, 40, 42],
    },
    {
      id: 2,
      color: 'black',
      price: 100,
      sale: 'no',
      product: 'Black Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
      size: [36, 38, 40, 42],
    },
    {
      id: 3,
      color: 'gray',
      price: 80,
      sale: 'yes',
      product: 'Gray Jumper',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
      size: [36, 38, 40],
    },
    {
      id: 4,
      color: 'gray',
      price: 80,
      sale: 'yes',
      product: 'Gray Jumper',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
      size: [40, 42],
    },
    {
      id: 5,
      color: 'red',
      price: 120,
      sale: 'yes',
      product: 'Red Hoodie',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
      size: [36, 40, 42],
    },
    {
      id: 6,
      color: 'blue',
      price: 90,
      sale: 'no',
      product: 'Blue Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
      size: [36, 38],
    },
  ];

  filteredItems$: Observable<Item[]>;
  filtersGroup: FormGroup;


  defaultFilters: Filters = {
    36: null,
    38: null,
    40: null,
    42: null,
    sale: null,
  };


  constructor() {
    this.filtersGroup = new FormGroup({
      36: new FormControl(),
      38: new FormControl(),
      40: new FormControl(),
      42: new FormControl(),
      sale: new FormControl(),
    });

    this.filteredItems$ = this.filtersGroup.valueChanges.pipe(
      startWith(this.defaultFilters),
      map((controls: Filters) => {
        let items = this.items;
        const sizes = Object.keys(controls)
          .filter((control) => controls[control] && !control.startsWith('sale'))
          .map((size) => Number(size));

        const sale = controls.sale;

        if (sizes.length > 0) {
          items = items.filter((item) =>
            sizes.some((checkboxSize) => item['size'].some((itemSize) => itemSize === checkboxSize))
          );
        }

        if (sale) {
          items = items.filter((item) => item.sale === sale);
        }
        return items;
      })
    );
  }

  clearFilters() {
    this.filtersGroup.reset();
  }
}

Spinner & Asynchronous Data example

Price:

...
Fantasy T-shirt

12.99$

Buy now
...
Fantasy T-shirt

12.99$

Buy now
...
Fantasy T-shirt

40.99$

Buy now
...
Denim Jacket

40.99$

Buy now
...
Ripped jeans

20.99$

Buy now
...
Boyfriend jeans

20.99$

Buy now
...
Ripped sweatshirt

29.99$

Buy now
...
Longsleeve

120.99$

Buy now
...
Stripped sweatshirt

32.99$

Buy now
...
Red chinos

62.99$

Buy now
...
Camel coat

62.99$

Buy now
...
Blue jeans

42.99$

Buy now
...
Orange T-shirt

12.99$

Buy now
...
Ballerina skirt

12.99$

Buy now
<h2 class="mb-4">Async example</h2>
<section class="border p-4 d-flex flex-column justify-content-center align-items-center mb-4">
  <p class="text-center fa-lg fw-bold">Price:</p>

  <form [formGroup]="filtersGroup">
    <div class="col-md-6 mt-3 d-flex justify-content-between text-center">
      <mdb-form-control>
        <input
          mdbInput
          type="number"
          id="min"
          name="min"
          class="form-control"
          formControlName="min"
        />
        <label mdbLabel class="form-label" for="min">Min</label>
      </mdb-form-control>

      <mdb-form-control>
        <input
          mdbInput
          type="number"
          id="max"
          name="max"
          class="form-control"
          formControlName="max"
        />
        <label mdbLabel class="form-label" for="max">Max</label>
      </mdb-form-control>
    </div>
  </form>
  <div *ngIf="loading" style="height: 300px; width: 100%; z-index: 1029" #container>
    <mdb-loading [backdrop]="false" [show]="true" [container]="container">
      <div class="loading-spinner">
        <div class="spinner-grow loading-icon" role="status"></div>
      </div>
    </mdb-loading>
  </div>
  <div class="row text-center">
    <div *ngFor="let item of filteredItems$ | async" class="col-md-4 mt-3"  style="max-width: 350px;">
      <div *ngIf="!loading" class="card shadow-2">
        <img [attr.src]="item.image" class="card-img-top" alt="..." />

        <div class="card-body">
          <h5 class="card-title">{{ item.product }}</h5>
          <p class="card-text">$ {{ item.price }}</p>
          <a href="#" class="btn btn-primary">Buy now</a>
        </div>
      </div>
    </div>

    <!--Section: Docs content-->
  </div>
import { HttpClient } from '@angular/common/http';
import { Component } from '@angular/core';
import { FormControl, FormGroup } from '@angular/forms';
import { Observable } from 'rxjs';
import { delay, map, startWith, switchMap } from 'rxjs/operators';

export interface Item {
  id: number;
  color: string;
  price: number;
  sale: string;
  product: string;
  image: string;
  size: number[];
}

export interface Filters {
  min: number | null;
  max: number | null;
}

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss'],
})
export class AppComponent {
  loading = true;

  filteredItems$: Observable<Item[]>;
  filtersGroup: FormGroup;

  defaultFilters: Filters = {
    min: null,
    max: null,
  };

  constructor(private http: HttpClient) {
    this.filtersGroup = new FormGroup({
      min: new FormControl(),
      max: new FormControl(),
    });

    this.filteredItems$ = this.filtersGroup.valueChanges.pipe(
      startWith(this.defaultFilters),
      switchMap((filters: Filters) => {
        this.loading = true;
        return http.get<Item[]>('/assets/products.json').pipe(
          delay(600),
          map((data: Item[]) => {
            const { min, max } = filters;
            let items: Item[] = data;
            this.loading = false;
            if (min && max) {
              items = data.filter((item) => item['price'] >= min && item['price'] <= max);
              return items;
            }
            if (min) {
              items = data.filter((item) => item['price'] >= min);
              return items;
            }
            if (max) {
              items = data.filter((item) => item['price'] <= max);
              return items;
            }

            return items;
          })
        );
      })
    );
  }

  clearFilters() {
    this.filtersGroup.reset();
  }
}
[
{
  "id": 1,
  "category": "shirts",
  "name": "Fantasy T-shirt",
  "rating": 4,
  "image": "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.webp",
  "description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
  "available": true,
  "size": ["34", "36", "40"],
  "condition": "new",
  "color": "blue",
  "price": 12.99,
  "keywords": ["t-shirt", "sweatshitrt"],
  "discount": 0,
  "gender": "male"
},
{
  "id": 2,
  "category": "shirts",
  "name": "Fantasy T-shirt",
  "rating": 5,
  "image": "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.webp",
  "description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
  "available": true,
  "size": ["34", "36", "40", "44"],
  "condition": "new",
  "color": "red",
  "price": 12.99,
  "discount": 0,
  "gender": "male"
},
{
  "id": 3,
  "category": "shirts",
  "name": "Fantasy T-shirt",
  "rating": 3,
  "image": "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.webp",
  "description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
  "available": true,
  "size": ["34", "36"],
  "condition": "new",
  "color": "grey",
  "price": 40.99,
  "discount": 10,
  "gender": "male"
},
{
  "id": 4,
  "category": "jackets",
  "name": "Denim Jacket",
  "rating": 5,
  "image": "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.webp",
  "description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
  "available": true,
  "condition": "new",
  "color": "grey",
  "price": 40.99,
  "discount": 0,
  "gender": "unisex"
},
{
  "id": 5,
  "category": "jeans",
  "name": "Ripped jeans",
  "rating": 5,
  "image": "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/11.webp",
  "description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
  "available": true,
  "size": ["34", "36", "38", "40"],
  "condition": "renewed",
  "color": "blue",
  "price": 20.99,
  "discount": 5,
  "gender": "female"
},
{
  "id": 6,
  "category": "jeans",
  "name": "Boyfriend jeans",
  "rating": 4,
  "image": "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/10.webp",
  "description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
  "available": false,
  "size": ["34", "36", "38", "40"],
  "condition": "used",
  "color": "blue",
  "price": 20.99,
  "discount": 5,
  "gender": "female"
},
{
  "id": 7,
  "category": "shirts",
  "name": "Ripped sweatshirt",
  "rating": 4,
  "image": "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/7.webp",
  "description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
  "available": true,
  "size": ["34", "36", "38", "40"],
  "condition": "collectible",
  "color": "white",
  "price": 29.99,
  "discount": 5,
  "gender": "female"
},
{
  "id": 8,
  "category": "shirts",
  "name": "Longsleeve",
  "rating": 4,
  "image": "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/8.webp",
  "description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
  "available": true,
  "size": ["40"],
  "condition": "collectible",
  "color": "black",
  "price": 120.99,
  "discount": 0,
  "gender": "male"
},
{
  "id": 8,
  "category": "shirts",
  "name": "Stripped sweatshirt",
  "rating": 4,
  "image": "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/6.webp",
  "description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
  "available": true,
  "size": ["40", "38", "36"],
  "condition": "new",
  "color": "white",
  "price": 32.99,
  "discount": 10,
  "gender": "female"
},
{
  "id": 9,
  "category": "trousers",
  "name": "Red chinos",
  "rating": 5,
  "image": "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/5.webp",
  "description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
  "available": true,
  "size": ["40", "38", "36"],
  "condition": "new",
  "color": "red",
  "price": 62.99,
  "discount": 10,
  "gender": "female"
},
{
  "id": 10,
  "category": "coats",
  "name": "Camel coat",
  "rating": 5,
  "image": "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/4.webp",
  "description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
  "available": true,
  "size": ["40", "38", "36"],
  "condition": "used",
  "color": "brown",
  "price": 62.99,
  "discount": 10,
  "gender": "female"
},
{
  "id": 11,
  "category": "jeans",
  "name": "Blue jeans",
  "rating": 5,
  "image": "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/3.webp",
  "description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
  "available": true,
  "size": ["40", "38", "36"],
  "condition": "new",
  "color": "blue",
  "price": 42.99,
  "discount": 0,
  "gender": "female"
},
{
  "id": 12,
  "category": "shirts",
  "name": "Orange T-shirt",
  "rating": 3,
  "image": "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/3.webp",
  "description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
  "available": true,
  "size": ["40", "38", "36"],
  "condition": "new",
  "color": "orange",
  "price": 12.99,
  "discount": 0,
  "gender": "female"
},
{
  "id": 13,
  "category": "skirts",
  "name": "Ballerina skirt",
  "rating": 4,
  "image": "https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/2.webp",
  "description": "Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.",
  "available": true,
  "size": ["38", "36"],
  "condition": "collectible",
  "color": "white",
  "price": 12.99,
  "discount": 0,
  "gender": "female"
}
  ]

Animations

The full list of available animations you can find here.

Filter: Color
Filter: Sale
...
Black Jeans Jacket

100$

Buy now
...
Black Jeans Jacket

100$

Buy now
...
Gray Jumper

80$

Buy now
...
Gray Jumper

80$

Buy now
...
Red Hoodie

120$

Buy now
...
Blue Jeans Jacket

90$

Buy now
<div class="container">
  <form [formGroup]="filtersGroup">
    <div class="col-md-6">
      <span class="fa-lg">Filter: Color</span>

      <div class="form-check mt-3">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="color"
          id="arrayRadio10"
          value="black"
          formControlName="color"
        />
        <label class="form-check-label" for="arrayRadio10">Black</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="color"
          id="arrayRadio20"
          value="red"
          formControlName="color"
        />
        <label class="form-check-label" for="arrayRadio20">Red</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="color"
          id="arrayRadio30"
          value="blue"
          formControlName="color"
        />
        <label class="form-check-label" for="arrayRadio30">Blue</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="color"
          id="arrayRadio40"
          value="gray"
          formControlName="color"
        />
        <label class="form-check-label" for="arrayRadio40">Gray</label>
      </div>
    </div>

    <div class="col-md-6">
      <span class="fa-lg mb-5">Filter: Sale</span>

      <div class="form-check mt-3">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="sale"
          id="arrayRadio50"
          value="yes"
          formControlName="sale"
        />
        <label class="form-check-label" for="arrayRadio50">Yes</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="sale"
          id="arrayRadio60"
          value="no"
          formControlName="sale"
        />
        <label class="form-check-label" for="arrayRadio60">No</label>
      </div>

      <button (click)="clearFilters()" type="button" class="btn btn-primary mt-3">
        Clear all filters
      </button>
    </div>
  </form>

  <div class="row text-center">
    <div *ngFor="let item of filteredItems$ | async" class="col-md-4 mt-3"  style="max-width: 350px;">
      <div
        class="card shadow-2"
        [@zoomIn]="animationState"
        (@zoomIn.done)="onAnimationDone()"
      >
        <img [attr.src]="item.img" class="card-img-top" alt="..." />
        <div class="card-body">
          <h5 class="card-title">{{ item.product }}</h5>
          <p class="card-text">{{ item.price }} $</p>
          <a href="#" class="btn btn-primary">Buy now</a>
        </div>
      </div>
    </div>
  </div>
</div>
import { Component } from '@angular/core';
import { FormControl, FormGroup } from '@angular/forms';
import { Observable } from 'rxjs';
import { map, startWith, tap } from 'rxjs/operators';
import { zoomInAnimation } from 'mdb-angular-ui-kit/animations';

export interface Item {
  id: number;
  color: string;
  price: number;
  sale: string;
  product: string;
  img: string;
  size: number[];
}

export interface Filters {
  color: string | null;
  sale: string | null;
}

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss'],
  animations: [zoomInAnimation()],
})
export class AppComponent {
  animationState = false;

  items: Item[] = [
    {
      id: 1,
      color: 'black',
      price: 100,
      sale: 'no',
      product: 'Black Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
      size: [36, 40, 42],
    },
    {
      id: 2,
      color: 'black',
      price: 100,
      sale: 'no',
      product: 'Black Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
      size: [36, 38, 40, 42],
    },
    {
      id: 3,
      color: 'gray',
      price: 80,
      sale: 'yes',
      product: 'Gray Jumper',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
      size: [36, 38, 40],
    },
    {
      id: 4,
      color: 'gray',
      price: 80,
      sale: 'yes',
      product: 'Gray Jumper',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
      size: [40, 42],
    },
    {
      id: 5,
      color: 'red',
      price: 120,
      sale: 'yes',
      product: 'Red Hoodie',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
      size: [36, 40, 42],
    },
    {
      id: 6,
      color: 'blue',
      price: 90,
      sale: 'no',
      product: 'Blue Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
      size: [36, 38],
    },
  ];

  filteredItems$: Observable<Item[]>;
  filtersGroup: FormGroup;

  defaultFilters: Filters = {
    color: null,
    sale: null,
  };
  constructor() {
    this.filtersGroup = new FormGroup({
      color: new FormControl(),
      sale: new FormControl(),
    });

    this.filteredItems$ = this.filtersGroup.valueChanges.pipe(
      startWith(this.defaultFilters),
      map((filters: Filters) => {
        const { color, sale } = filters;
        let items = this.items;
        if (color) {
          items = items.filter((item) => item.color === color);
        }

        if (sale) {
          items = items.filter((item) => item.sale === sale);
        }

        return items;
      }),
      tap(() =>
        setTimeout(() => {
          this.animationState = !this.animationState;
        }, 0)
      )
    );
  }

  clearFilters() {
    this.filtersGroup.reset();
  }

  onAnimationDone() {
    this.animationState = false;
  }
}

Filter and sort

Filter: Color
Filter: Sale
Choose category
...
Black Jeans Jacket

100$

Buy now
...
Black Jeans Jacket

100$

Buy now
...
Gray Jumper

80$

Buy now
...
Gray Jumper

80$

Buy now
...
Red Hoodie

120$

Buy now
...
Blue Jeans Jacket

90$

Buy now
<div class="container">
  <form [formGroup]="filtersGroup">
    <div class="col-md-6">
      <span class="fa-lg">Filter: Color</span>

      <div class="form-check mt-3">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="color"
          id="arrayRadioSort1"
          value="black"
          formControlName="color"
        />
        <label class="form-check-label" for="arrayRadioSort1">Black</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="color"
          id="arrayRadioSort2"
          value="red"
          formControlName="color"
        />
        <label class="form-check-label" for="arrayRadioSort2">Red</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="color"
          id="arrayRadioSort3"
          value="blue"
          formControlName="color"
        />
        <label class="form-check-label" for="arrayRadioSort3">Blue</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="color"
          id="arrayRadioSort4"
          value="gray"
          formControlName="color"
        />
        <label class="form-check-label" for="arrayRadioSort4">Gray</label>
      </div>
    </div>

    <div class="col-md-6 my-3">
      <span class="fa-lg mb-5">Filter: Sale</span>

      <div class="form-check mt-3">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="sale"
          id="arrayRadioSort5"
          value="yes"
          formControlName="sale"
        />
        <label class="form-check-label" for="arrayRadioSort5">Yes</label>
      </div>

      <div class="form-check">
        <input
          mdbInput
          class="form-check-input"
          type="radio"
          name="sale"
          id="arrayRadioSort6"
          value="no"
          formControlName="sale"
        />
        <label class="form-check-label" for="arrayRadioSort6">No</label>
      </div>

      <button (click)="clearFilters()" type="button" class="btn btn-primary mt-3">
        Clear all filters
      </button>
    </div>

    <mdb-form-control>
      <mdb-select formControlName="sorting">
        <mdb-option *ngFor="let option of options" [value]="option.value">{{
          option.label
        }}</mdb-option>
      </mdb-select>
      <label mdbLabel class="form-label">Sort</label>
    </mdb-form-control>
  </form>

  <div class="row text-center">
    <div *ngFor="let item of filteredItems$ | async" class="col-md-4 mt-3"  style="max-width: 350px;">
      <div class="card shadow-2">
        <img [attr.src]="item.img" class="card-img-top" alt="..." />
        <div class="card-body">
          <h5 class="card-title">{{ item.product }}</h5>
          <p class="card-text">{{ item.price }} $</p>
          <a href="#" class="btn btn-primary">Buy now</a>
        </div>
      </div>
    </div>
  </div>
</div>
import { Component } from '@angular/core';
import { FormControl, FormGroup } from '@angular/forms';
import { Observable } from 'rxjs';
import { map, startWith, } from 'rxjs/operators';

export interface Item {
  id: number;
  color: string;
  price: number;
  sale: string;
  product: string;
  img: string;
  size: number[];
}
export interface Filters {
  color: string | null;
  sale: string | null;
  sorting: string | null;
}


@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss'],
})
export class AppComponent {
  options = [
    { value: 'productasc', label: 'Product name ascending' },
    { value: 'productdesc', label: 'Product name descending' },
    { value: 'pricedesc', label: 'Highest price' },
    { value: 'priceasc', label: 'Lowest price' },
  ];

  items: Item[] = [
    {
      id: 1,
      color: 'black',
      price: 100,
      sale: 'no',
      product: 'Black Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
      size: [36, 40, 42],
    },
    {
      id: 2,
      color: 'black',
      price: 100,
      sale: 'no',
      product: 'Black Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
      size: [36, 38, 40, 42],
    },
    {
      id: 3,
      color: 'gray',
      price: 80,
      sale: 'yes',
      product: 'Gray Jumper',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
      size: [36, 38, 40],
    },
    {
      id: 4,
      color: 'gray',
      price: 80,
      sale: 'yes',
      product: 'Gray Jumper',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
      size: [40, 42],
    },
    {
      id: 5,
      color: 'red',
      price: 120,
      sale: 'yes',
      product: 'Red Hoodie',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
      size: [36, 40, 42],
    },
    {
      id: 6,
      color: 'blue',
      price: 90,
      sale: 'no',
      product: 'Blue Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
      size: [36, 38],
    },
  ];

  filteredItems$: Observable<Item[]>;

  filtersGroup: FormGroup;

  sortDefaultFilters: Filters = {
    color: null,
    sale: null,
    sorting: null,
  };

  constructor() {
    this.filtersGroup = new FormGroup({
      color: new FormControl(),
      sale: new FormControl(),
      sorting: new FormControl(),
    });

    this.filteredItems$ = this.filtersGroup.valueChanges.pipe(
      startWith(this.sortDefaultFilters),
      map((filters: Filters) => {
        const { color, sale, sorting } = filters;
        let items = this.items;

        if (color) {
          items = items.filter((item) => item.color === color);
        }

        if (sale) {
          items = items.filter((item) => item.sale === sale);
        }

        if (sorting && sorting.startsWith('product')) {
          items = items.sort((a, b) =>
            sorting.endsWith('asc')
              ? a['product'].localeCompare(b['product'])
              : -1 * a['product'].localeCompare(b['product'])
          );
        }

        if (sorting && sorting.startsWith('price')) {
          items = items.sort((a, b) =>
            sorting.endsWith('asc') ? a['price'] - b['price'] : b['price'] - a['price']
          );
        }
        return items;
      })
    );
  }

  clearFilters() {
    this.filtersGroup.reset();
  }
}

Range example

Price:

Current: 80$

Current: 120$

Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
Blue Jeans Jacket
Blue Jeans Jacket

90$

Buy now
Red Hoodie
Red Hoodie

150$ 120$

Buy now
Black Jeans Jacket
Black Jeans Jacket

100$

Buy now
Gray Jumper
Gray Jumper

100$ 80$

Buy now
<div class="container">
  <form [formGroup]="filtersGroup">
    <div class="col-md-6">
      <mdb-range formControlName="min" [min]="80" [max]="120"></mdb-range>
      Current min ${{ rangeMin }}
      <mdb-range formControlName="max" [min]="80" [max]="120"></mdb-range>
      Current max ${{ rangeMax }}
    </div>
  </form>

  <div class="row text-center">
    <div *ngFor="let item of filteredItems$ | async" class="col-md-4 mt-3">
      <div class="card shadow-2">
        <img [attr.src]="item.img" class="card-img-top" alt="..." />
        <div class="card-body">
          <h5 class="card-title">{{ item.product }}</h5>
          <p class="card-text">{{ item.price }} $</p>
          <a href="#" class="btn btn-primary">Buy now</a>
        </div>
      </div>
    </div>
  </div>
</div>
import { Component } from '@angular/core';
import { FormControl, FormGroup } from '@angular/forms';
import { Observable } from 'rxjs';
import { map, startWith } from 'rxjs/operators';

export interface Item {
  id: number;
  color: string;
  price: number;
  sale: string;
  product: string;
  img: string;
  size: number[];
}

export interface Filters {
  min: number;
  max: number;
}


@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss'],
})
export class AppComponent {
  items: Item[] = [
    {
      id: 1,
      color: 'black',
      price: 100,
      sale: 'no',
      product: 'Black Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
      size: [36, 40, 42],
    },
    {
      id: 2,
      color: 'black',
      price: 100,
      sale: 'no',
      product: 'Black Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
      size: [36, 38, 40, 42],
    },
    {
      id: 3,
      color: 'gray',
      price: 80,
      sale: 'yes',
      product: 'Gray Jumper',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
      size: [36, 38, 40],
    },
    {
      id: 4,
      color: 'gray',
      price: 80,
      sale: 'yes',
      product: 'Gray Jumper',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
      size: [40, 42],
    },
    {
      id: 5,
      color: 'red',
      price: 120,
      sale: 'yes',
      product: 'Red Hoodie',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
      size: [36, 40, 42],
    },
    {
      id: 6,
      color: 'blue',
      price: 90,
      sale: 'no',
      product: 'Blue Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
      size: [36, 38],
    },
  ];

  filteredItems$: Observable<Item[]>;
  filtersGroup: FormGroup;

  rangeMin = 80;
  rangeMax = 120;

  defaultFilters: Filters = {
    min: 80,
    max: 120,
  };


  constructor() {
    this.filtersGroup = new FormGroup({
      min: new FormControl(80),
      max: new FormControl(120),
    });

    this.filteredItems$ = this.filtersGroup.valueChanges.pipe(
      startWith({min: 80, max: 120}),
      map((filters: Filters) => {
        const { min, max } = filters;
        let items = this.items;
        this.rangeMin = min;
        this.rangeMax = max;
        if (min && max) {
          items = items.filter((item) => item['price'] >= min && item['price'] <= max);
          return items;
        }

        if (min) {
          items = items.filter((item) => item['price'] >= min);
          return items;
        }

        if (max) {
          items = items.filter((item) => item['price'] <= max);
          return items;
        }

        return items;
      })
    );
  }

  clearFilters() {
    this.filtersGroup.reset();
  }
}

Buttons example

...
Black Jeans Jacket

100$

Buy now
...
Black Jeans Jacket

100$

Buy now
...
Gray Jumper

80$

Buy now
...
Gray Jumper

80$

Buy now
...
Red Hoodie

120$

Buy now
...
Blue Jeans Jacket

90$

Buy now
<div class="container">
  <form [formGroup]="filtersGroup">
    <div class="col-md-6">
      <div class="form-check mt-3">
        <button
          type="button"
          class="btn btn-primary"
          (click)="filtersGroup.get('sort')?.setValue('asc')"
        >
          Sort by product name ascending
        </button>
      </div>

      <div class="form-check">
        <button
          type="button"
          class="btn btn-primary"
          (click)="filtersGroup.get('sort')?.setValue('desc')"
        >
          Sort by product name descending
        </button>
      </div>
    </div>
  </form>

  <div class="row text-center">
    <div *ngFor="let item of filteredItems$ | async" class="col-md-4 mt-3"  style="max-width: 350px;">
      <div class="card shadow-2">
        <img [attr.src]="item.img" class="card-img-top" alt="..." />
        <div class="card-body">
          <h5 class="card-title">{{ item.product }}</h5>
          <p class="card-text">{{ item.price }} $</p>
          <a href="#" class="btn btn-primary">Buy now</a>
        </div>
      </div>
    </div>
  </div>
</div>
import { Component } from '@angular/core';
import { FormControl, FormGroup } from '@angular/forms';
import { Observable } from 'rxjs';
import { map, startWith } from 'rxjs/operators';

export interface Item {
  id: number;
  color: string;
  price: number;
  sale: string;
  product: string;
  img: string;
  size: number[];
}

export interface Filters {
  sort: string | null;
}

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss'],
})
export class AppComponent {
  items: Item[] = [
    {
      id: 1,
      color: 'black',
      price: 100,
      sale: 'no',
      product: 'Black Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
      size: [36, 40, 42],
    },
    {
      id: 2,
      color: 'black',
      price: 100,
      sale: 'no',
      product: 'Black Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
      size: [36, 38, 40, 42],
    },
    {
      id: 3,
      color: 'gray',
      price: 80,
      sale: 'yes',
      product: 'Gray Jumper',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
      size: [36, 38, 40],
    },
    {
      id: 4,
      color: 'gray',
      price: 80,
      sale: 'yes',
      product: 'Gray Jumper',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
      size: [40, 42],
    },
    {
      id: 5,
      color: 'red',
      price: 120,
      sale: 'yes',
      product: 'Red Hoodie',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
      size: [36, 40, 42],
    },
    {
      id: 6,
      color: 'blue',
      price: 90,
      sale: 'no',
      product: 'Blue Jeans Jacket',
      img: 'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
      size: [36, 38],
    },
  ];

  filteredItems$: Observable<Item[]>;
  filtersGroup: FormGroup;

  basicButtonFilters: Filters = {
    sort: null,
  };

  constructor() {
    this.filtersGroup = new FormGroup({
      sort: new FormControl(),
    });

    this.filteredItems$ = this.filtersGroup.valueChanges.pipe(
      startWith(this.basicButtonFilters),
      map((filters: Filters) => {
        const { sort } = filters;
        let items = this.items;

        if (sort) {
          items = items.sort((a, b) =>
            sort === 'asc'
              ? a['product'].localeCompare(b['product'])
              : -1 * a['product'].localeCompare(b['product'])
          );
        }

        return items;
      })
    );
  }

  clearFilters() {
    this.filtersGroup.reset();
  }
}

Full page example

<header>
  <!-- Navbar -->
  <nav class="navbar sticky-top navbar-expand-lg bg-white">
    <!-- Container wrapper -->
    <div class="container-fluid">
      <!-- Navbar brand -->

      <!-- Toggle button -->
      <button
        class="navbar-toggler"
        type="button"
        (click)="buttonsNav.toggle()"
        aria-expanded="false"
        aria-label="Toggle navigation"
      >
        <i class="fas fa-bars"></i>
      </button>

      <!-- Collapsible wrapper -->
      <div
        class="collapse navbar-collapse"
        id="navbarButtonsExample"
        mdbCollapse
        #buttonsNav="mdbCollapse"
      >
        <!-- Left links -->
        <ul class="navbar-nav me-auto mb-2 mb-lg-0">
          <a class="navbar-brand" href="https://mdbecommerce.com/">
            <i class="fab fa-mdb fa-2x" alt="mdb logo"></i>
          </a>
        </ul>
        <!-- Right links -->

        <ul class="navbar-nav ml-auto">
          <li class="nav-item my-auto">
            <a class="nav-link active" aria-current="page" href="#"
              ><span class="badge rounded-pill bg-danger">1</span
              ><i class="fas fa-shopping-cart"></i
            ></a>
          </li>
          <!-- Navbar dropdown -->
          <div mdbDropdown class="dropdown my-auto">
            <a
              class="dropdown-toggle text-black"
              role="button"
              id="dropdownMenuLink"
              mdbDropdownToggle
              aria-expanded="false"
            >
              <i class="united kingdom flag m-0"></i>
            </a>
            <ul
              mdbDropdownMenu
              class="dropdown-menu"
              aria-labelledby="dropdownMenuLink"
            >
              <li><a class="dropdown-item" href="#">Action</a></li>
              <li><a class="dropdown-item" href="#">Another action</a></li>
              <li><a class="dropdown-item" href="#">Something else here</a></li>
            </ul>
          </div>

          <li class="nav-item my-auto">
            <a class="nav-link active" aria-current="page" href="#">Shop</a>
          </li>
          <li class="nav-item my-auto">
            <a class="nav-link active" aria-current="page" href="#">Contact</a>
          </li>
          <li class="nav-item my-auto">
            <a class="nav-link active" aria-current="page" href="#">Sign in</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="#"
              ><button
                type="button"
                class="btn btn-outline-dark btn-rounded"
                mdbRipple rippleColor="dark"
              >
                Sign up
              </button></a
            >
          </li>
        </ul>
      </div>
      <!-- Collapsible wrapper -->
    </div>
    <!-- Container wrapper -->
  </nav>
  <!-- Navbar -->
  <div
    class="p-5 text-center bg-image"
    style="
      background-image: url('https://mdbootstrap.com/img/Photos/Others/clothes(5)-crop.jpg');
      height: 400px;
    "
  >
    <div class="mask" style="background-color: rgba(0, 0, 0, 0.7)">
      <div class="d-flex justify-content-center align-items-center h-100">
        <div class="text-white">
          <h1 class="mb-3">Shop</h1>
        </div>
      </div>
    </div>
  </div>
</header>
<main>
  <div class="container mt-5" [formGroup]="filtersGroup">
    <div class="row">
      <div class="col-md-4">
        <!-- Section: Sidebar -->
        <section>
          <!-- Section: Filters -->
          <section id="filters" data-auto-filter="true">
            <h5>Filters</h5>

            <!-- Section: Condition -->
            <section class="mb-4">
              <h6 class="font-weight-bold mb-3">Condition</h6>

              <div class="form-check mb-3">
                <input
                  mdbCheckbox
                  class="form-check-input"
                  type="checkbox"
                  value="new"
                  id="checkbox1"
                  formControlName="conditionNew"
                />
                <label class="form-check-label" for="checkbox1"> NEW </label>
              </div>

              <div class="form-check mb-3">
                <input
                  mdbCheckbox
                  class="form-check-input"
                  type="checkbox"
                  value="used"
                  id="checkbox2"
                  formControlName="conditionUsed"
                />
                <label class="form-check-label" for="checkbox2"> USED </label>
              </div>
              <div class="form-check mb-3">
                <input
                  mdbCheckbox
                  class="form-check-input"
                  type="checkbox"
                  value="collectible"
                  id="checkbox3"
                  formControlName="conditionCollectible"
                />
                <label class="form-check-label" for="checkbox3">
                  COLLECTIBLE
                </label>
              </div>

              <div class="form-check mb-3">
                <input
                  mdbCheckbox
                  class="form-check-input"
                  type="checkbox"
                  value="renewed"
                  id="checkbox4"
                  formControlName="conditionRenewed"
                />
                <label class="form-check-label" for="checkbox4">
                  RENEWED
                </label>
              </div>
            </section>
            <!-- Section: Condition -->

            <!-- Section: Avg. Customer Review -->
            <section class="mb-4">
              <h6 class="font-weight-bold mb-3">Avg. Customer Review</h6>

              <mdb-rating
                (onSelect)="filtersGroup.get('rating')?.setValue($event)"
                style="cursor: pointer"
              >
                <mdb-rating-icon
                  mdbTooltip="1"
                  class="text-primary"
                ></mdb-rating-icon>
                <mdb-rating-icon
                  mdbTooltip="2"
                  class="text-primary"
                ></mdb-rating-icon>
                <mdb-rating-icon
                  mdbTooltip="3"
                  class="text-primary"
                ></mdb-rating-icon>
                <mdb-rating-icon
                  mdbTooltip="4"
                  class="text-primary"
                ></mdb-rating-icon>
                <mdb-rating-icon
                  mdbTooltip="5"
                  class="text-primary"
                ></mdb-rating-icon>
              </mdb-rating>
            </section>
            <!-- Section: Avg. Customer Review -->

            <!-- Section: Price -->
            <section class="mb-4">
              <h6 class="font-weight-bold mb-3">Price</h6>
              <div class="form-check mb-3">
                <input
                  mdbRadio
                  class="form-check-input"
                  type="radio"
                  name="price"
                  id="radio1"
                  formControlName="price"
                  value="<25"
                />
                <label class="form-check-label" for="radio1"> Under $25 </label>
              </div>

              <div class="form-check mb-3">
                <input
                  mdbRadio
                  class="form-check-input"
                  type="radio"
                  name="price"
                  id="radio2"
                  formControlName="price"
                  value="25-50"
                />
                <label class="form-check-label" for="radio2">
                  $25 to $50
                </label>
              </div>

              <div class="form-check mb-3">
                <input
                  mdbRadio
                  class="form-check-input"
                  type="radio"
                  name="price"
                  id="radio3"
                  formControlName="price"
                  value="50-100"
                />
                <label class="form-check-label" for="radio3">
                  $50 to $100
                </label>
              </div>

              <div class="form-check mb-3">
                <input
                  mdbRadio
                  class="form-check-input"
                  type="radio"
                  name="price"
                  id="radio4"
                  formControlName="price"
                  value="100-200"
                />
                <label class="form-check-label" for="radio4">
                  $100 to $200
                </label>
              </div>
              <div class="form-check mb-3">
                <input
                  mdbRadio
                  class="form-check-input"
                  type="radio"
                  name="price"
                  id="radio5"
                  formControlName="price"
                  value=">200"
                />
                <label class="form-check-label" for="radio5">
                  $200 & above
                </label>
              </div>
            </section>
            <!-- Section: Price -->

            <!-- Section: Size -->
            <section class="mb-4" data-filter="size">
              <h6 class="font-weight-bold mb-3">Size</h6>

              <div class="form-check mb-3">
                <input
                  mdbCheckbox
                  class="form-check-input"
                  type="checkbox"
                  value="34"
                  id="checkbox5"
                  formControlName="size34"
                />
                <label class="form-check-label" for="checkbox5"> 34 </label>
              </div>

              <div class="form-check mb-3">
                <input
                  mdbCheckbox
                  class="form-check-input"
                  type="checkbox"
                  value="36"
                  id="checkbox6"
                  formControlName="size36"
                />
                <label class="form-check-label" for="checkbox6"> 36 </label>
              </div>
              <div class="form-check mb-3">
                <input
                  mdbCheckbox
                  class="form-check-input"
                  type="checkbox"
                  value="38"
                  id="checkbox7"
                  formControlName="size38"
                />
                <label class="form-check-label" for="checkbox7"> 38 </label>
              </div>

              <div class="form-check mb-3">
                <input
                  mdbCheckbox
                  class="form-check-input"
                  type="checkbox"
                  value="40"
                  id="checkbox8"
                  formControlName="size40"
                />
                <label class="form-check-label" for="checkbox8"> 40 </label>
              </div>
            </section>
            <!-- Section: Size -->

            <!-- Section: Color -->
            <section class="mb-4" data-filter="color">
              <h6 class="font-weight-bold mb-3">Color</h6>

              <div class="form-check form-check-inline mx-0 px-0 py-3">
                <input
                  formControlName="color"
                  mdbRadio
                  class="btn-check"
                  type="radio"
                  name="color"
                  id="colorRadio1"
                  value="white"
                />
                <label
                  class="btn bg-light btn-rounded p-3"
                  for="colorRadio1"
                ></label>
              </div>

              <div class="form-check form-check-inline mx-0">
                <input
                  formControlName="color"
                  mdbRadio
                  class="btn-check"
                  type="radio"
                  name="color"
                  id="colorRadio2"
                  value="grey"
                />
                <label
                  class="btn btn-rounded p-3"
                  for="colorRadio2"
                  style="background-color: #bdbdbd"
                ></label>
              </div>

              <div class="form-check form-check-inline mx-0">
                <input
                  formControlName="color"
                  mdbRadio
                  class="btn-check"
                  type="radio"
                  name="color"
                  id="colorRadio3"
                  value="black"
                />
                <label
                  class="btn bg-dark text-white btn-rounded p-3"
                  for="colorRadio3"
                ></label>
              </div>

              <div class="form-check form-check-inline mx-0">
                <input
                  formControlName="color"
                  mdbRadio
                  class="btn-check"
                  type="radio"
                  name="color"
                  id="colorRadio5"
                  value="blue"
                />
                <label
                  class="btn bg-primary btn-rounded p-3"
                  for="colorRadio5"
                ></label>
              </div>

              <div class="form-check form-check-inline mx-0">
                <input
                  formControlName="color"
                  mdbRadio
                  class="btn-check"
                  type="radio"
                  name="color"
                  id="colorRadio9"
                  value="red"
                />
                <label
                  class="btn bg-danger btn-rounded p-3"
                  for="colorRadio9"
                ></label>
              </div>

              <div class="form-check form-check-inline mx-0">
                <input
                  formControlName="color"
                  mdbRadio
                  class="btn-check"
                  type="radio"
                  name="color"
                  id="colorRadio10"
                  value="orange"
                />
                <label
                  class="btn bg-warning btn-rounded p-3"
                  for="colorRadio10"
                ></label>
              </div>
            </section>
            <!-- Section: Color -->
          </section>
          <!-- Section: Filters -->
        </section>
        <!-- Section: Sidebar -->
      </div>
      <div class="col-md-8">
        <div class="row justify-content-center">
          <div class="col-md-6 my-auto py-3">
            <mdb-form-control>
              <mdb-select formControlName="sort">
                <mdb-option
                  *ngFor="let option of options"
                  [value]="option.value"
                  >{{ option.label }}</mdb-option
                >
              </mdb-select>
              <label mdbLabel class="form-label">Sort</label>
            </mdb-form-control>
          </div>
        </div>
        <div class="row mb-4" id="content" style="display: flex">
          <div class="row text-center">
            <h3 *ngIf="noItemsFound" class="text-center mt-5">
              No items found
            </h3>
            <div
              *ngFor="let item of filteredItems$ | async"
              class="col-md-4 mt-3"
              style="max-width: 350px"
            >
              <div class="card shadow-2">
                <img [attr.src]="item.image" class="card-img-top" alt="..." />
                <div class="card-body">
                  <h5 class="card-title">{{ item.name }}</h5>
                  <p class="card-text">{{ item.price }} $</p>
                  <a href="#" class="btn btn-primary">Buy now</a>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</main>
<footer class="bg-dark text-white text-center text-lg-left">
  <!-- Socials -->
  <div class="bg-primary text-center p-3">
    <div class="row">
      <div class="col-md-6">
        <span class="font-weight-bold"
          >Get connected with us on social networks!</span
        >
      </div>
      <div class="col-md-6">
        <i class="fab fa-instagram"></i>
        <i class="fab fa-linkedin-in ms-4"></i>
        <i class="fab fa-twitter ms-4"></i>
        <i class="fab fa-facebook-f ms-4"></i>
      </div>
    </div>
  </div>
  <!-- Socials -->

  <!-- Grid container -->
  <div class="container p-5">
    <!--Grid row-->
    <div class="row p-2">
      <!--Grid column-->
      <div class="col-md-3 mx-auto py-4 text-start">
        <h5 class="text-uppercase">About me</h5>
        <hr class="mb-4 mt-0" />

        <p>
          Here you can use rows and columns to organize your footer content.
          Lorem ipsum dolor sit amet, consectetur adipisicing elit.
        </p>
      </div>
      <!--Grid column-->

      <!--Grid column-->
      <div class="col-md-3 mx-auto py-4">
        <h5 class="text-uppercase text-start">Products</h5>
        <hr class="mb-4 mt-0" />

        <ul class="list-unstyled mb-0 text-start">
          <li class="mb-2">
            <a href="#!" class="text-white">MDBootstrap</a>
          </li>
          <li class="mb-2">
            <a href="#!" class="text-white">MDWordPress</a>
          </li>
          <li class="mb-2">
            <a href="#!" class="text-white">BrandFlow</a>
          </li>
          <li>
            <a href="#!" class="text-white">Bootstrap Angular</a>
          </li>
        </ul>
      </div>
      <!--Grid column-->

      <!--Grid column-->
      <div class="col-md-3 mx-auto py-4">
        <h5 class="text-uppercase text-start">Useful links</h5>
        <hr class="mb-4 mt-0" />

        <ul class="list-unstyled text-start">
          <li class="mb-2">
            <a href="#!" class="text-white">Your Account</a>
          </li>
          <li class="mb-2">
            <a href="#!" class="text-white">Become an Affiliate</a>
          </li>
          <li class="mb-2">
            <a href="#!" class="text-white">Shipping Rates</a>
          </li>
          <li>
            <a href="#!" class="text-white">Help</a>
          </li>
        </ul>
      </div>
      <!--Grid column-->

      <!--Grid column-->
      <div class="col-md-3 mx-auto py-4">
        <h5 class="text-uppercase text-start">Contacts</h5>
        <hr class="mb-4 mt-0" />

        <ul class="list-unstyled text-start">
          <li class="mb-2">
            <a href="#!" class="text-white"
              ><i class="far fa-map mr-1"></i> New York, Avenue Street 10</a
            >
          </li>
          <li class="mb-2">
            <a href="#!" class="text-white"
              ><i class="fas fa-phone-alt mr-1"></i> 042 876 836 908</a
            >
          </li>
          <li class="mb-2">
            <a href="#!" class="text-white"
              ><i class="far fa-envelope mr-1"></i> company@example.com</a
            >
          </li>
          <li>
            <a href="#!" class="text-white"
              ><i class="far fa-clock mr-1"></i> Monday - Friday: 10-17</a
            >
          </li>
        </ul>
      </div>
      <!--Grid column-->
    </div>
    <!--Grid row-->
  </div>
  <!-- Grid container -->

  <!-- Copyright -->
  <div class="text-center p-3" style="background-color: rgba(0, 0, 0, 0.2)">
    © 2020 Copyright:
    <a class="text-white" href="https://mdbootstrap.com/">MDBootstrap.com</a>
  </div>
  <!-- Copyright -->
</footer>
import { Component } from '@angular/core';
import { FormControl, FormGroup } from '@angular/forms';
import { Observable } from 'rxjs';
import { map, startWith } from 'rxjs/operators';

export interface Item {
  id: number;
  category: string;
  name: string;
  rating: number;
  image: string;
  description: string;
  available: boolean;
  size: string[] | number[];
  condition: string;
  color: string;
  price: number;
  discount: number;
  gender: string;
  keywords?: string[];
}

export interface Filters {
  sale: string | null;
  sort: string | null;
  color: string | null;
  conditionNew: boolean | null;
  conditionUsed: boolean | null;
  conditionCollectible: boolean | null;
  conditionRenewed: boolean | null;
  rating: number | null;
  price: number | null;
  size34: number | null;
  size36: number | null;
  size38: number | null;
  size40: number | null;
}

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss'],
})
export class AppComponent {
  filteredItems$: Observable<Item[]>;
  filtersGroup: FormGroup;

  defaultFilters: Filters = {
    color: null,
    sale: null,
    sort: null,
    conditionNew: null,
    conditionUsed: null,
    conditionCollectible: null,
    conditionRenewed: null,
    rating: null,
    price: null,
    size34: null,
    size36: null,
    size38: null,
    size40: null,
  };

  options = [
    { value: 'ratingdesc', label: 'Best rating' },
    { value: 'pricedesc', label: 'Higest price first' },
    { value: 'priceasc', label: 'Lowest price first' },
  ];

  noItemsFound = false;

  items: Item[] = [
    {
      id: 1,
      category: 'shirts',
      name: 'Fantasy T-shirt',
      rating: 4,
      image:
        'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/12.webp',
      description:
        'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
      available: true,
      size: ['34', '36', '40'],
      condition: 'new',
      color: 'blue',
      price: 12.99,
      keywords: ['t-shirt', 'sweatshitrt'],
      discount: 0,
      gender: 'male',
    },
    {
      id: 2,
      category: 'shirts',
      name: 'Fantasy T-shirt',
      rating: 5,
      image:
        'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/13.webp',
      description:
        'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
      available: true,
      size: ['34', '36', '40', '44'],
      condition: 'new',
      color: 'red',
      price: 12.99,
      discount: 0,
      gender: 'male',
    },
    {
      id: 3,
      category: 'shirts',
      name: 'Fantasy T-shirt',
      rating: 3,
      image:
        'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/14.webp',
      description:
        'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
      available: true,
      size: ['34', '36'],
      condition: 'new',
      color: 'grey',
      price: 40.99,
      discount: 10,
      gender: 'male',
    },
    {
      id: 4,
      category: 'jackets',
      name: 'Denim Jacket',
      rating: 5,
      size: [],
      image:
        'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/15.webp',
      description:
        'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
      available: true,
      condition: 'new',
      color: 'grey',
      price: 40.99,
      discount: 0,
      gender: 'unisex',
    },
    {
      id: 5,
      category: 'jeans',
      name: 'Ripped jeans',
      rating: 5,
      image:
        'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/11.webp',
      description:
        'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
      available: true,
      size: ['34', '36', '38', '40'],
      condition: 'renewed',
      color: 'blue',
      price: 20.99,
      discount: 5,
      gender: 'female',
    },
    {
      id: 6,
      category: 'jeans',
      name: 'Boyfriend jeans',
      rating: 4,
      image:
        'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/10.webp',
      description:
        'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
      available: false,
      size: ['34', '36', '38', '40'],
      condition: 'used',
      color: 'blue',
      price: 20.99,
      discount: 5,
      gender: 'female',
    },
    {
      id: 7,
      category: 'shirts',
      name: 'Ripped sweatshirt',
      rating: 4,
      image:
        'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/7.webp',
      description:
        'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
      available: true,
      size: ['34', '36', '38', '40'],
      condition: 'collectible',
      color: 'white',
      price: 29.99,
      discount: 5,
      gender: 'female',
    },
    {
      id: 8,
      category: 'shirts',
      name: 'Longsleeve',
      rating: 4,
      image:
        'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/8.webp',
      description:
        'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
      available: true,
      size: ['40'],
      condition: 'collectible',
      color: 'black',
      price: 120.99,
      discount: 0,
      gender: 'male',
    },
    {
      id: 8,
      category: 'shirts',
      name: 'Stripped sweatshirt',
      rating: 4,
      image:
        'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/6.webp',
      description:
        'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
      available: true,
      size: ['40', '38', '36'],
      condition: 'new',
      color: 'white',
      price: 32.99,
      discount: 10,
      gender: 'female',
    },
    {
      id: 9,
      category: 'trousers',
      name: 'Red chinos',
      rating: 5,
      image:
        'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/5.webp',
      description:
        'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
      available: true,
      size: ['40', '38', '36'],
      condition: 'new',
      color: 'red',
      price: 62.99,
      discount: 10,
      gender: 'female',
    },
    {
      id: 10,
      category: 'coats',
      name: 'Camel coat',
      rating: 5,
      image:
        'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/4.webp',
      description:
        'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
      available: true,
      size: ['40', '38', '36'],
      condition: 'used',
      color: 'brown',
      price: 62.99,
      discount: 10,
      gender: 'female',
    },
    {
      id: 11,
      category: 'jeans',
      name: 'Blue jeans',
      rating: 5,
      image:
        'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/3.webp',
      description:
        'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
      available: true,
      size: ['40', '38', '36'],
      condition: 'new',
      color: 'blue',
      price: 42.99,
      discount: 0,
      gender: 'female',
    },
    {
      id: 12,
      category: 'shirts',
      name: 'Orange T-shirt',
      rating: 3,
      image:
        'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/3.webp',
      description:
        'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
      available: true,
      size: ['40', '38', '36'],
      condition: 'new',
      color: 'orange',
      price: 12.99,
      discount: 0,
      gender: 'female',
    },
    {
      id: 13,
      category: 'skirts',
      name: 'Ballerina skirt',
      rating: 4,
      image:
        'https://mdbcdn.b-cdn.net/img/Photos/Horizontal/E-commerce/Vertical/2.webp',
      description:
        'Lorem ipsum dolor sit amet consectetur adipisicing elit. Numquam, sapiente illo. Sit error voluptas repellat rerum quidem, soluta enim perferendis voluptates laboriosam.',
      available: true,
      size: ['38', '36'],
      condition: 'collectible',
      color: 'white',
      price: 12.99,
      discount: 0,
      gender: 'female',
    },
  ];

  constructor() {
    this.filtersGroup = new FormGroup({
      color: new FormControl(),
      sale: new FormControl(),
      conditionNew: new FormControl(),
      conditionUsed: new FormControl(),
      conditionCollectible: new FormControl(),
      conditionRenewed: new FormControl(),
      rating: new FormControl(),
      price: new FormControl(),
      size34: new FormControl(),
      size36: new FormControl(),
      size38: new FormControl(),
      size40: new FormControl(),
      sort: new FormControl()
    });

    this.filteredItems$ = this.filtersGroup.valueChanges.pipe(
      startWith(this.defaultFilters),
      map((controls: Filters) => {
        const { rating, price, color, sort } = controls;
        let items = this.items;
        const conditions = Object.keys(controls)
          .filter(
            (control) =>
              controls[control as keyof Filters] &&
              control.startsWith('condition')
          )
          .map((string) => string.toLowerCase().replace('condition', ''));

        if (conditions.length > 0) {
          items = items.filter((item) =>
          conditions.some((condition) => item.condition === condition)
          );
        }

        if (rating) {
          items = items.filter((item) => item['rating'] === rating)
        }

        if (price) {
          if (price.toString().startsWith('<')) {
            items = items.filter((item) => item['price'] < Number(price.toString().split('<')[1]));
          }
          if (price.toString().startsWith('>')) {
            items = items.filter((item) => item['price'] > Number(price.toString().split('>')[1]));
          }
          if (price.toString().split('-').length === 2) {
            items = items.filter((item) => item['price'] > Number(price.toString().split('-')[0]) && item['price'] < Number(price.toString().split('-')[1]))
          }

        }

        const sizes = Object.keys(controls)
        .filter(
          (control) =>
            controls[control as keyof Filters] &&
            control.startsWith('size')
        )
        .map((string) => Number(string.toLowerCase().replace('size', '')));
        this.noItemsFound = false;
        if (sizes.length > 0) {
          items = items.filter((item) =>
            sizes.some((checkboxSize) => item['size'].some((itemSize) => itemSize === checkboxSize.toString()))
          );
        }

        if (color) {
          console.log(color)
          items = items.filter((item) => item['color'] === color);
        }

        if (sort && sort.startsWith('price')) {
          items = items.sort((a, b) =>
            sort.endsWith('asc') ? a['price'] - b['price'] : b['price'] - a['price']
          );
        }

        if (sort && sort.startsWith('rating')) {
          items = items.sort((a, b) =>
            sort.endsWith('asc') ? a['rating'] - b['rating'] : b['rating'] - a['rating']
          );
        }

        if (items.length < 1) {
          this.noItemsFound = true;
        }
        return items;
      })
    );
  }

  clearFilters() {
    this.filtersGroup.reset();
  }
}

Filters - API


Import

import { ReactiveFormsModule } from '@angular/forms';
  …
  @NgModule ({
    ...
    imports: [ReactiveFormsModule],
    ...
  })